var currentVersion="1.8.16.2"
//setting current version using the format (year-2022).monthInt.dayInt.intraday

console.log("Novation SL MK3 - MC Custom Script [Version: "+currentVersion+"]")

var midiremote_api=require('midiremote_api_v1')

var pathOfSettingsFileFile
var pathOfSettingsFile 

try {

    pathOfSettingsFileFile=require("./pathOfSettingsFile")
    pathOfSettingsFile="./"+pathOfSettingsFileFile.settingsPath

} catch (error) {

    pathOfSettingsFile="./mapOfGeneralSetttings"

}

var generalSettingsFile

try {

    generalSettingsFile=require(pathOfSettingsFile)

} catch (error) {
    
    generalSettingsFile=require("./mapOfGeneralSettings")

}

var generalSettings=generalSettingsFile.generalSettings

var mapOfBindindsFile="./"+generalSettings.mapOfBindindsFile

var mapOfBindings

try {

    mapOfBindings=require(mapOfBindindsFile)

} catch (error) {

    mapOfBindings=require("./mapOfBindings")

}


var bindings=mapOfBindings.bindings

var colors=mapOfBindings.colors

var bindingsDisplayMap={}



var bindingsDisplayRows={knobLeft:0,knobRight:0,button:3,pad:4,rewind:2,forward:2,stop:2,play:2,loop:2,record:2,duplicate:2,clear:2}

var bindingsDisplayColumns={duplicate:0,clear:1,rewind:2,forward:3,stop:4,play:5,loop:6,record:7}

var bindingsDisplayColorMap={button:"underDisplay",pad:"pads"}



var cV={} // Controller Variables

cV.initialized=false 
cV.lstOfSysexUponActivating=[]

cV.channelsProperties={}


cV.cursor=""
cV.leftLocator=""
cV.rightLocator=""
cV.BPM=0
cV.clickLevel=0
cV.quantizePreset=""
cV.metroActive=0

cV.displayColumnLength=9

cV.displays={}
cV.leds={}

cV.msFromLastKnobTurn=0

//MCU handlers
cV.ccValueLeft=65
cV.ccValueRight=1
cV.ccBrowseUpDown=18
cV.ccBrowseSendUpDown=16//add send slot index

cV.ccBrowseInstrument=80

cV.ccBrowseInsert=43
cV.ccBrowseInsert2=16//value set to insert's index  

cV.ccBrowseStrip=45
cV.ccBrowseStrip2=16//value set to strip effect's index 

cV.ccBrowseSend=41
cV.ccBrowseSend2=49//send three times 

//-----------------------------------

cV.constDefaultChannelOfDAW=15 

cV.constBtnWidth=2
cV.constBtnHeight=1 

cV.sysexHeader=[0xf0,0x00,0x20,0x29,0x02,0x0a,0x01]

const cText=0x01
const cColor=0x04
const cValue=0x03 


cV.clearAllLeds=[0x03]

for(var ledID=0;ledID<68;ledID++){

    cV.clearAllLeds.push(ledID,1,0,0,0)

}

cV.colorsPerButtonPerSubPage={}

cV.colorsPerButtonPerSubPage["eq"]=[colors.red,colors.red,colors.green,colors.green,colors.blue,colors.blue,colors.yellow,colors.yellow]

cV.colorsPerButtonPerSubPage["shift"]=[colors.white,colors.red,colors.green,colors.blue,colors.yellow,colors.yellow_green,colors.azure,colors.coral]

cV.colorsPerButtonPerSubPage["eq2"]=[colors.red,colors.red,colors.green,colors.green,colors.blue,colors.blue,colors.yellow,colors.yellow]

cV.colorsPerButtonPerSubPage["qc"]=[colors.red,colors.red,colors.green,colors.blue,colors.yellow,colors.bisque,colors.dark_sea_green,colors.burly_wood]

cV.colorsPerButtonPerSubPage["fqc"]=[colors.red,colors.red,colors.green,colors.blue,colors.yellow,colors.bisque,colors.dark_sea_green,colors.burly_wood]

cV.colorsPerButtonPerSubPage["fqc2"]=[colors.red,colors.red,colors.green,colors.blue,colors.yellow,colors.bisque,colors.dark_sea_green,colors.burly_wood]

cV.colorsPerButtonPerSubPage["pregain"]=[colors.gray,colors.red,colors.blue,colors.black,colors.black,colors.black,colors.black,colors.black]

cV.colorsPerButtonPerSubPage["gate"]=[colors.blue,colors.gray,colors.green,colors.red,colors.black,colors.black,colors.black,colors.black,colors.black,colors.black,colors.black,colors.black]

cV.colorsPerButtonPerSubPage["comp"]=[colors.blue,colors.gray,colors.green,colors.red,colors.black,colors.black,colors.black,colors.black,colors.black,colors.black,colors.black,colors.black]

cV.colorsPerButtonPerSubPage["tools"]=[colors.blue,colors.gray,colors.green,colors.red,colors.black,colors.black,colors.black,colors.black,colors.black,colors.black,colors.black,colors.black]

cV.colorsPerButtonPerSubPage["sat"]=[colors.blue,colors.gray,colors.green,colors.red,colors.black,colors.black,colors.black,colors.black,colors.black,colors.black,colors.black,colors.black]

cV.colorsPerButtonPerSubPage["limit"]=[colors.blue,colors.gray,colors.green,colors.red,colors.black,colors.black,colors.black,colors.black,colors.black,colors.black,colors.black,colors.black]


cV.colorsPerButtonPerSubPage["inserts"]=[colors.blue,colors.gray,colors.green,colors.red,colors.yellow,colors.white,colors.coral]

cV.colorsPerButtonPerSubPage["sends"]=[colors.brown,colors.brown,colors.brown,colors.brown,colors.brown,colors.brown,colors.brown,colors.brown]

cV.colorsPerButtonPerSubPage["sends2"]=[colors.sky_blue,colors.sky_blue,colors.sky_blue,colors.sky_blue,colors.sky_blue,colors.sky_blue,colors.sky_blue,colors.sky_blue]


cV.colorsPerSubPageButton1Faders={

    "muteSolo": [colors.yellow,colors.red],
    "readWrite": [colors.green,colors.red],
    "monitorDefeat": [colors.brown,colors.yellow],
    "armSelect": [colors.red,colors.white],
    
}

cV.colorsPerMainSection=[]

cV.dontDisplayValuesSubPages=["shift","shift2","ctrl","alt","fn","commands1","commands2","commands3","commands4","commands5","fqc","fqc2","qc","inserts","gate","comp","tools","sat","limit","grid","options"]

cV.constPageNameMixer="mixer"

cV.subPagesForDawInfoDisplay=["shift","shift2","ctrl","alt","fn","commands1","commands2","commands3","commands4","commands5"]

cV.stripSubPages=["gate","comp","tools","sat","limit"]



//***************************************************************************
var deviceDriver = midiremote_api.makeDeviceDriver('Novation', 'SL MK3 MC Custom', 'Minas Chantzides')

deviceDriver.setUserGuide("Novation Sl MK3 MC Custom Script.pdf")

var midiInput = deviceDriver.mPorts.makeMidiInput()
var midiOutput = deviceDriver.mPorts.makeMidiOutput()

deviceDriver.makeDetectionUnit().detectPortPair(midiInput, midiOutput)
    .expectInputNameContains('MIDIIN2')
    .expectInputNameContains('Novation SL MkIII')
    .expectOutputNameContains('MIDIOUT2')
    .expectOutputNameContains('Novation SL MkIII')
    .expectSysexIdentityResponse('002029','0101','0000')

// Windows RT
deviceDriver
.makeDetectionUnit()
.detectPortPair(midiInput, midiOutput)
.expectInputNameContains('SL MkIII')
.expectInputNameContains('Port 2')
.expectOutputNameContains('SL MkIII')
.expectOutputNameContains('Port 2')
.expectSysexIdentityResponse('002029','0101','0000')

//MAC
deviceDriver
  .makeDetectionUnit()
  .detectPortPair(midiInput, midiOutput)
  .expectInputNameEquals("Novation SL MkIII SL MkIII InControl")
  .expectOutputNameEquals("Novation SL MkIII SL MkIII InControl")

var midiInputMIDILOOP
var midiOutputMIDILOOP

if(generalSettings.strippedDownVersion!=1){

    midiInputMIDILOOP = deviceDriver.mPorts.makeMidiInput("loopin")
    midiOutputMIDILOOP = deviceDriver.mPorts.makeMidiOutput("loopout")

    deviceDriver.makeDetectionUnit().detectPortPair(midiInput, midiOutput)
        .expectInputNameEquals('loopMIDI Port')
        .expectOutputNameEquals('loopMIDI Port 1')

    // Windows RT
    deviceDriver.makeDetectionUnit().detectPortPair(midiInput, midiOutput)
        .expectInputNameContains('loopMIDI')
        .expectInputNameContains('Port [1]')
        .expectOutputNameContains('loopMIDI')
        .expectOutputNameContains('Port 1 [1]')

    

    midiInputMIDILOOP.mOnSysex=function(activeDevice,midiMessage){
       
        var messageToString=midiMessage.toString()
        
        if(messageToString.substring(0,17)=="240,0,0,102,20,18"){
            
            if(midiMessage[6]<28){
                

                var lastMCUCommandTimeStampToInt=parseInt(activeDevice.getState("lastMCUCommandTimeStamp"))
                if(lastMCUCommandTimeStampToInt+generalSettings.mcuAllowDisplayMs>new Date().getTime()){

                    var lengthOfMessage=midiMessage.length
                    var maxCharIndex
                    if(lengthOfMessage>24){
                    
                        maxCharIndex=23

                    } else {
                        
                        maxCharIndex=lengthOfMessage-1
                    
                    }
                
                    var newArr=midiMessage.slice(7,maxCharIndex)
                    
                    var mcuInfo=String.fromCharCode.apply(this,newArr).trim()
                    
                    notify(activeDevice,["Received",mcuInfo])
                    
                }

            }

        }
    
    }

}


function sendSysex(activeDevice,commandID,elementIndex,data){

    var finalData=cV.sysexHeader.concat([commandID,elementIndex],data,[0xf7])

    midiOutput.sendMidi(activeDevice,finalData)

}


function sendOrAppendToSysEx(activeDevice,/**@type {Array}*/ data,/**@type {Array}*/ append){
    
    var maxMsgSize=500
    var newData

    if(data.length+append.length>maxMsgSize){
    
        sendLongSysex(activeDevice,data)
        newData=[data[0]].concat(append)
    
    } else {

        newData=data.concat(append)
    
    }

    return newData 
    
}

/**
 * 
 * @param {Array} data
*/
function sendLongSysex(activeDevice,data){

    var finalData=cV.sysexHeader.concat(data,[0xf7])

    midiOutput.sendMidi(activeDevice,finalData)

}

deviceDriver.mOnActivate=function(activeDevice){
    
    //sendSysex(activeDevice,1,2,[]) //button layout
    sendSysex(activeDevice,1,1,[]) //knob layout
    
    updateNightModeButtons(activeDevice)

    updateDisplay(activeDevice,8,cText,1,"Mixer",0,0,0,0)
    
    cV.initialized=true 

    if (cV.lstOfSysexUponActivating.length>0){
        
        cV.lstOfSysexUponActivating.forEach(function(sysex){
    
            midiOutput.sendMidi(activeDevice,sysex)
    
        })
    
        cV.lstOfSysexUponActivating=[]
    
    }

    activeDevice.setState("pageSelected",cV.constPageNameMixer)
    
    notify(activeDevice,["Cubase 12 MIDI","Remote Script MC"])

    
    
}


deviceDriver.mOnDeactivate=function(activeDevice){
    
    midiOutput.sendMidi(activeDevice,cV.sysexHeader.concat([1,0,0xf7]))
    midiOutput.sendMidi(activeDevice,cV.sysexHeader.concat(cV.clearAllLeds,[0xf7]))
    
    notify(activeDevice,["Script","Deactivated"])
    
}

var surface=deviceDriver.mSurface

var ourSurface=makeSurface()

var dawDefaults=midiremote_api.mDefaults

makeHostMapping(dawDefaults,deviceDriver,ourSurface,surface,midiOutput)

function makeSurface(){

    function makeButton(x,y,cc,height){
        
        y=y+1
        var button=surface.makeButton(x*cV.constBtnWidth,y*cV.constBtnHeight,cV.constBtnWidth,height*cV.constBtnHeight)
        
        if(cc>0){

            button.mSurfaceValue.mMidiBinding.setInputPort(midiInput)
            button.mSurfaceValue.mMidiBinding.bindToControlChange(cV.constDefaultChannelOfDAW,cc)
        
        }
        
        return button 
        
    }

    function makeKnob(x,y,knobIndex){
        
        var cc=knobIndex+0x15
        
        var knob=surface.makeKnob(x*cV.constBtnWidth,y*cV.constBtnHeight,cV.constBtnWidth,cV.constBtnHeight*2)
        
        knob.mSurfaceValue.mMidiBinding
            .setInputPort(midiInput)
            .bindToControlChange(cV.constDefaultChannelOfDAW,cc)
            .setTypeRelativeTwosComplement()
            
        surf.knobs[knobIndex]=knob
        
        var knobLeft=surface.makeCustomValueVariable("knobLeft"+knobIndex)
        var knobRight=surface.makeCustomValueVariable("knobRight"+knobIndex)
        
        surf.knobsLeft[knobIndex]=knobLeft 
        surf.knobsRight[knobIndex]=knobRight 

    }

    function makeFader(x,y,faderIndex){
        y=y+1
        var cc=faderIndex+0x29

        var fader=surface.makeFader(x*cV.constBtnWidth,y*cV.constBtnHeight,cV.constBtnWidth,cV.constBtnHeight*5)
        
        fader.mSurfaceValue.mMidiBinding
            .setInputPort(midiInput)
            .bindToControlChange(cV.constDefaultChannelOfDAW,cc)
        
        surf.faders[faderIndex]=fader
        
    }

    function makePad(x,y,padIndex,note){
        
        y=y+1
        var pad=surface.makeTriggerPad(x*cV.constBtnWidth,y*cV.constBtnHeight,cV.constBtnWidth,cV.constBtnHeight*2)
        
        pad.mSurfaceValue.mMidiBinding
            .setInputPort(midiInput)
            .bindToNote(cV.constDefaultChannelOfDAW,note)
        
        surf.pads[padIndex]=pad
        
    }

    function makeCustomVariable(customVariableName,cc){
        
        var customVariable=surface.makeCustomValueVariable(customVariableName)
        
        if(cc>0){
            
            customVariable.mMidiBinding.setInputPort(midiInput)
            
            customVariable.mMidiBinding.bindToControlChange(cV.constDefaultChannelOfDAW,cc)
            
        }

        return customVariable
        
    }

    function makeLabel(fieldName,fieldValue,x,y,height){
        
        y=y+1
        var label={}
        
        label.labelField=surface.makeLabelField(x*cV.constBtnWidth,y*cV.constBtnHeight,cV.constBtnWidth,cV.constBtnHeight*height)

        label.text=fieldValue

        return label 
    
    }

    
    var surf={}
    
    surf.knobs={}
    
    surf.knobsLeft={}
    surf.knobsRight={}
    
    surf.buttons={}
    
    surf.buttonsScreen={}
    
    surf.buttonsFaders1={}
    
    surf.buttonsFaders2={}
    
    surf.pads={}
    
    surf.faders={}
    
    surf.dummy={}

    surf.displays={}

    
    surf.buttons.shift=makeButton(0,1.5,0x5B,1)
    
    surf.buttons.duplicate=makeButton(0,6,0x5C,1)
    
    surf.buttons.clear=makeButton(0,7,0x5D,1)
    
    surf.buttons.trackLeft=makeButton(0,8,0x66,1)
    
    surf.buttons.trackRight=makeButton(1,8,0x67,1)
    
    surf.buttons.arrowUpScreen=makeButton(3,1,0x51,1)
    
    surf.buttons.arrowDnScreen=makeButton(3,2,0x52,1)
    
    surf.buttons.grid=makeButton(3,5,0x59,1)
    
    surf.buttons.arrowUpPads=makeButton(3,6,0x55,2)
    
    surf.buttons.arrowDnPads=makeButton(3,8,0x56,2)
    
    surf.buttons.options=makeButton(12,5,0x5A,1)
    
    surf.buttons.arrowRightA=makeButton(12,6,0x53,2)
    
    surf.buttons.arrowRightB=makeButton(12,8,0x54,2)
    
    surf.buttons.arrowUpRight=makeButton(23,1,0x57,1)
    
    surf.buttons.arrowDnRight=makeButton(23,2,0x58,1)
    
    surf.buttons.rewind=makeButton(23.5,9,0x70,1.5)
    
    surf.buttons.forward=makeButton(24.5,9,0x71,1.5)
    
    surf.buttons.stop=makeButton(25.5,9,0x72,1.5)
    
    surf.buttons.play=makeButton(26.5,9,0x73,1.5)
    
    surf.buttons.loop=makeButton(27.5,9,0x74,1.5)
    
    surf.buttons.record=makeButton(28.5,9,0x75,1.5)
    
    cV.leds.underDisplay={}
    cV.leds.aboveFaders1={}
    cV.leds.aboveFaders2={}
    cV.leds.faders={}
    cV.leds.pads={}

    cV.leds.rewind={ledID: 0x21,solidFlashPulse:1,r:0,g:0,b:0}
    cV.leds.forward={ledID: 0x22,solidFlashPulse:1,r:0,g:0,b:0}
    cV.leds.stop={ledID: 0x23,solidFlashPulse:1,r:127,g:127,b:127}
    cV.leds.play={ledID: 0x24,solidFlashPulse:1,r:0,g:127,b:0}
    cV.leds.loop={ledID: 0x25,solidFlashPulse:1,r:0,g:0,b:127}
    cV.leds.record={ledID: 0x20,solidFlashPulse:1,r:127,g:0,b:0}
    
    cV.leds.duplicate={ledID: 0x42,solidFlashPulse:1,r:0,g:127,b:0,night: colors.green}
    cV.leds.clear={ledID: 0x43,solidFlashPulse:1,r:0,g:0,b:127,night: colors.red}
    cV.leds.trackLeft={ledID: 0x1e,solidFlashPulse:1,r:0,g:0,b:127,night: colors.antique_white,shiftColor: colors.yellow}
    cV.leds.trackRight={ledID: 0x1f,solidFlashPulse:1,r:0,g:0,b:127,night: colors.antique_white,shiftColor: colors.yellow}

    cV.leds.grid={ledID: 0x40,solidFlashPulse:1,r:0,g:0,b:127,night: colors.coral}
    cV.leds.options={ledID: 0x41,solidFlashPulse:1,r:0,g:0,b:127,night: colors.dark_sea_green}

    cV.leds.arrowUpScreen={ledID: 0x3e,solidFlashPulse:1,r:0,g:0,b:127,night: colors.light_green,shiftColor: colors.green}
    cV.leds.arrowDnScreen={ledID: 0x3f,solidFlashPulse:1,r:0,g:0,b:127, night: colors.light_green,shiftColor:colors.green}

    cV.leds.arrowUpPads={ledID: 0x00,solidFlashPulse:1,r:0,g:0,b:127,night: colors.light_yellow, shiftColor: colors.white}
    cV.leds.arrowDnPads={ledID: 0x01,solidFlashPulse:1,r:0,g:0,b:127,night: colors.light_yellow, shiftColor: colors.white}

    cV.leds.arrowRightA={ledID: 0x02,solidFlashPulse:1,r:0,g:0,b:127,night: colors.azure}
    cV.leds.arrowRightB={ledID: 0x03,solidFlashPulse:1,r:0,g:0,b:127,night: colors.azure}

    cV.leds.arrowUpRight={ledID: 0x1c,solidFlashPulse:1,r:0,g:0,b:127, night: colors.white},
    cV.leds.arrowDnRight={ledID: 0x1d,solidFlashPulse:1,r:0,g:0,b:127, night: colors.white}

    for(var i=0;i<8;i++){

        cV.displays[i]={}
        
        cV.channelsProperties[i]={name:"",pluginName:"",colorR:0,colorG:0,colorB:0,active:0,autoRead:0,autoWrite:0,selected:0,armRecord:0,solo:0,mute:0,volume:"",pan:"",volume127: 0}
        
        var ledID=0x04+i 
        cV.leds.underDisplay[i]={ledID: ledID,solidFlashPulse:1,r:0,g:0,b:0}

        ledID=0x36+i
        cV.leds.faders[i]={ledID: ledID,solidFlashPulse:1,r:0,g:0,b:0}

        ledID=0x0c+i
        cV.leds.aboveFaders1[i]={ledID: ledID,solidFlashPulse:1,r:127,g:127,b:0}

        ledID=0x14+i
        cV.leds.aboveFaders2[i]={ledID: ledID,solidFlashPulse:1,r:0,g:127,b:0}

        ledID=38+i
        cV.leds.pads[i]={ledID: ledID,solidFlashPulse:1,r:0,g:127,b:0}

        ledID=46+i
        var i2=8+i
        cV.leds.pads[i2]={ledID: ledID,solidFlashPulse:1,r:0,g:127,b:0}

        for(var displayRowIndex=0;displayRowIndex<5;displayRowIndex++){

            cV.displays[i][displayRowIndex]={text: "",colorR:0,colorG:0,colorB:0}

        }

        makeKnob(4+i,0,i)

        
        if(i % 2==0 || i==7){
            var iBlind=i==7 ? 8 : i 
            surface.makeBlindPanel((4+iBlind)*cV.constBtnWidth,cV.constBtnHeight*2,cV.constBtnWidth*2,cV.constBtnHeight*3)
        }
        
        makeFader(15+i,5,i)

        surf.buttonsScreen[i]=makeButton(4+i,5,0x33+i,1)
        
        makePad(4+i,6,i,0x60+i)
        var padIndex8=8+i
        makePad(4+i,8,padIndex8,0x70+i)
        
        surf.buttonsFaders1[i]=makeButton(15+i,1,0x3B+i,1)
        
        surf.buttonsFaders2[i]=makeButton(15+i,2,0x43+i,1)
        
    }

    surf.custom={}

    surf.custom.shift=surface.makeCustomValueVariable("shiftUp")
    
    surf.custom.shift2=surface.makeCustomValueVariable("shift2Up")
    
    surf.custom.ctrl=surface.makeCustomValueVariable("ctrlUp")
    
    surf.custom.alt=surface.makeCustomValueVariable("altUp")
    
    surf.custom.fn=surface.makeCustomValueVariable("fnUp")
    
    surf.custom.grid=surface.makeCustomValueVariable("gridUp")
    
    surf.custom.options=surface.makeCustomValueVariable("optionsUp")

    surf.custom.statesOff=surface.makeCustomValueVariable("statesOff")
    
    surf.custom.shiftArrows=surface.makeCustomValueVariable("shiftArrows")
    surf.custom.shiftArrowsUp=surface.makeCustomValueVariable("shiftArrowsUp")

    surf.custom.buttons=[]

    for(var index=0;index<8;index++){

        surf.custom.buttons.push(surface.makeCustomValueVariable("customButton"+index))
    
    }

    surf.custom.soloDefeat=surface.makeCustomValueVariable("soloDefeat")

    surf.custom.deactivateAllSolo=surface.makeCustomValueVariable("deactivateAllSolo")

    surf.custom.unumuteAll=surface.makeCustomValueVariable("unmuteAll")

    surf.custom.readAutoAll=surface.makeCustomValueVariable("readAutoAll")

    surf.custom.writeAutoAll=surface.makeCustomValueVariable("writeAutoAll")

    surf.custom.armAllAudio=surface.makeCustomValueVariable("armAllAudio")

    surf.custom.disarmAllAudio=surface.makeCustomValueVariable("disarmAllAudio")





    //handles for generic remote, when in the full version of the script 
    if(generalSettings.strippedDownVersion==0){
        
        surf.genericRemote={}
        
        //using channel 15 (i.e. 16) for the generic remote, to not conflict with the mcu integration of loopMIDI, which uses port 9
        
        //this one comes from the mcu
        surf.genericRemote.punchInFromLoopMidi=surface.makeCustomValueVariable("punchInFromLoopMIDI")
        surf.genericRemote.punchInFromLoopMidi.mMidiBinding
            .setInputPort(midiInputMIDILOOP)    
            .bindToNote(0,0x57)
        
        surf.genericRemote.punchOutFromLoopMidi=surface.makeCustomValueVariable("punchOutFromLoopMIDI")
        surf.genericRemote.punchOutFromLoopMidi.mMidiBinding
            .setInputPort(midiInputMIDILOOP)    
            .bindToNote(15,0x58)

        surf.genericRemote.midiRecordModeFromLoopMidi=surface.makeCustomValueVariable("midiRecordModeFromLoopMIDI")
        surf.genericRemote.midiRecordModeFromLoopMidi.mMidiBinding
            .setInputPort(midiInputMIDILOOP)    
            .bindToNote(15,0x5F)

        surf.genericRemote.midiRecordCycleModeFromLoopMidi=surface.makeCustomValueVariable("midiRecordCycleModeFromLoopMIDI")
        surf.genericRemote.midiRecordCycleModeFromLoopMidi.mMidiBinding
            .setInputPort(midiInputMIDILOOP)    
            .bindToNote(15,0x60)

        surf.genericRemote.metronomePrecountFromLoopMidi=surface.makeCustomValueVariable("metronomePrecountFromLoopMIDI")
        surf.genericRemote.metronomePrecountFromLoopMidi.mMidiBinding
            .setInputPort(midiInputMIDILOOP)    
            .bindToNote(15,0x61)

    }

    surf.dummy.metronomeActive=surface.makeButton(0,0,0,0)
    surf.dummy.clickLevel=surface.makeKnob(0,0,0,0)
    //these are used for properly listening to the value change of metronome active and its click level, because our default bindings are in subPages

    surf.dummy.buttonsSelect=[]

    for(var channelIndex=0;channelIndex<8;channelIndex++){
    
        surf.dummy.buttonsSelect.push(surface.makeButton(0,0,0,0))

    }


    //labels for missing descriptions
    surf.labels={}

    surf.labels.shift=makeLabel("shift","Shift",0,1.5,1)
    surf.labels.grid=makeLabel("grid","Grid",3,5,1)
    surf.labels.arrowUpPads=makeLabel("arrowUpPads","ScUp",3,6.5,1)
    surf.labels.arrowDnPads=makeLabel("arrowDnPads","ScDn",3,8.5,1)
    surf.labels.options=makeLabel("options","Opt.",12,5,1)
    
    surf.labels.shift2=makeLabel("shift2","Shf2",4,10,1)
    surf.labels.ctrl=makeLabel("ctrl","Ctrl",5,10,1)
    surf.labels.alt=makeLabel("alt","Alt",6,10,1)
    surf.labels.fn=makeLabel("fn","Fn",7,10,1)

    return surf 

}

/**
 * @param {MR_HostDefaults} hostDefaults
 * @param {MR_DeviceDriver} deviceDriver
 * @param {Object} surfaceElements
 * @param {MR_DeviceSurface} surface 
 * @param {MR_DeviceMidiOutput} midiOutput 
 */
function makeHostMapping(hostDefaults, deviceDriver, surfaceElements, surface, midiOutput) {

    var resPages=[]
    
    resPages.push(makePageMixer())

    for(var userPagesIndex=0;userPagesIndex<generalSettings.userMappingPagesNames.length;userPagesIndex++){

        var userPageName=generalSettings.userMappingPagesNames[userPagesIndex]
        resPages.push(makeCustomPage(userPageName))
    
    }

    for(var pageIndex=0;pageIndex<resPages.length;pageIndex++){

        var resPage=resPages[pageIndex]

        resPage.page.mOnActivate=(function(activeDevice){

            this.onActivate(activeDevice)
        
        }).bind({onActivate: resPage.onActivate})

        resPage.page.mOnDeactivate=function(activeDevice){

            clearAllLeds(activeDevice)
       
        }
    
    }

    for(var index=0;index<8;index++){

        ourSurface.dummy.buttonsSelect[index].mSurfaceValue.mOnProcessValueChange=function(activeDevice,value,diff){
            
                updateSelectedTrack(activeDevice,this.index,value)
               
        }.bind({index})

        ourSurface.dummy.buttonsSelect[index].mSurfaceValue.mOnTitleChange=function(activeDevice,title1,title2){
           
            activeDevice.setState("selectedTrackName"+this.index,title1)
            var currentPage=activeDevice.getState("selectedPage")
            
            if((activeDevice.getState("subPageShift")=="mixer" || activeDevice.getState("subPageShift")=="") && currentPage==cV.constPageNameMixer){

                if(generalSettings.display.pluginName==1){
                   
                    updateDisplay(activeDevice,this.index,cText,2,title1,0,0,0,0)
            
                } else {

                    sendTextTwoLines(activeDevice,this.index,2,title1)
                
                }

            }

        }.bind({index})

        ourSurface.dummy.buttonsSelect[index].mSurfaceValue.mOnColorChange=function(activeDevice,r,g,b,a,isActive){
            
            updateSelectedTrackColor(activeDevice,this.index,r,g,b,a,isActive,isSubPageSelected(activeDevice,"mixer") && activeDevice.getState("selectedPage")=="mixer")

            
        }.bind({index})

       ourSurface.buttonsScreen[index].mSurfaceValue.mOnTitleChange=function(activeDevice,title1,title2){
            
            var currentPage=activeDevice.getState("selectedPage")
            if(currentPage!=cV.constPageNameMixer){

                updateDisplay(activeDevice,this.index,cText,2,title1+"-"+title2)
                
                return 
                
            }

        }.bind({index})

        ourSurface.buttonsScreen[index].mSurfaceValue.mOnDisplayValueChange=function(activeDevice,displayValue){

            var currentPage=activeDevice.getState("selectedPage")
            if(currentPage!=cV.constPageNameMixer){
                
                updateDisplay(activeDevice,this.index,cText,3,displayValue)
                
                return 
                
            }
            
        }.bind({index})
        
        ourSurface.buttonsScreen[index].mSurfaceValue.mOnProcessValueChange=function(activeDevice,value){

            var currentPage=activeDevice.getState("selectedPage")
            if(currentPage!=cV.constPageNameMixer){

                return 

            }
            
            var currentSubPageName=activeDevice.getState("subPageShift")
            
            if(currentSubPageName!="mixer"){
                    
                var ledObject=cV.leds.underDisplay[this.index]
                if(cV.colorsPerButtonPerSubPage[currentSubPageName]!=undefined){
             
                    var rgbArr=cV.colorsPerButtonPerSubPage[currentSubPageName][this.index]
                    if(rgbArr!=undefined){
                        
                        var fixColor=value==0 ? generalSettings.buttonsUnderDisplayIntensity : 1
                        var r=rgbArr[0]*fixColor
                        var g=rgbArr[1]*fixColor
                        var b=rgbArr[2]*fixColor
                        ledObject.r=r
                        ledObject.g=g
                        ledObject.b=b
                        
                        updateLed(activeDevice,ledObject)

                        updateDisplay(activeDevice,this.index,cColor,2,"",r,g,b,0)

                        updateDisplay(activeDevice,this.controlIndex,cValue,1,"",0,0,0,value)

                    }
                
                }
            
            } 

        }.bind({index})

        ourSurface.knobs[index].mSurfaceValue.mOnDisplayValueChange=function(activeDevice,displayValue){
            
            var currentPage=activeDevice.getState("selectedPage")
            
            if(currentPage!=cV.constPageNameMixer){
                
                var row0=1
            
                updateDisplay(activeDevice,this.index,cText,row0,displayValue,0,0,0,0)
            
                return 

            }
            
            var currentSubPage=activeDevice.getState("subPageShift")
            
            var subPageShiftPreActivation=activeDevice.getState("subPageShiftPreActivation")     
           
            if(subPageShiftPreActivation=="grid" || subPageShiftPreActivation=="options"){
                    
                return 

            }

            if(this.index==6 && (["shift","shift2","ctrl","alt","fn","options","grid"].indexOf(currentSubPage)!=-1 || currentSubPage.indexOf("commands")==0)){

                //click level, already handled
                return 

            }

            var row=2
          
            if(currentSubPage=="mixer" || currentSubPage==""){
            
                return // handled by pan mOndisplay
            
            }
            
            updateDisplay(activeDevice,this.index,cText,row,displayValue,0,0,0,0)
        
        }.bind({index})
        
        ourSurface.knobs[index].mSurfaceValue.mOnProcessValueChange=function(activeDevice,value,diff){
        
            var byte=Math.round(127*value)

            var currentPage=activeDevice.getState("selectedPage")

            if(currentPage!=cV.constPageNameMixer){
                
                updateDisplay(activeDevice,this.index,cValue,0,"",0,0,0,byte)

                return 

            }
            
            var currentSubPage=activeDevice.getState("subPageShift")    
            var subPageShiftPreActivation=activeDevice.getState("subPageShiftPreActivation")     
            
            if(currentSubPage!="grid" && currentSubPage!="options" && subPageShiftPreActivation!="grid" && subPageShiftPreActivation!="options" && currentSubPage!="mixer"){

              updateDisplay(activeDevice,this.index,cValue,0,"",0,0,0,byte)

            }

            turnLeftRight(activeDevice,this.index,value,diff)
            
        }.bind({index})

        ourSurface.buttonsScreen[index].mSurfaceValue.mOnColorChange=function(activeDevice,r,g,b,a,isActive){

            var currentPage=activeDevice.getState("selectedPage")

            if(currentPage!=cV.constPageNameMixer){
                
                updateDisplay(activeDevice,this.index,cColor,2,"",Math.round(127*r),Math.round(127*g),Math.round(127*b),0)

                return 

            }

        }.bind({index})

        ourSurface.knobs[index].mSurfaceValue.mOnTitleChange=function(activeDevice,pluginName,paramName){
            
            var currentPage=activeDevice.getState("selectedPage")
          
            if(currentPage!=cV.constPageNameMixer){
        
                updateDisplay(activeDevice,this.index,cText,0,paramName,0,0,0,0)
        
                return 

            }
            
            var currentSubPage=activeDevice.getState("subPageShift")
            
            var subPageShiftPreActivation=activeDevice.getState("subPageShiftPreActivation")     
                
            if(subPageShiftPreActivation=="grid" || subPageShiftPreActivation=="options"){
            
                return 
                
            }

            if(this.index==6 && (["shift","shift2","ctrl","alt","fn"].indexOf(currentSubPage)!=-1 || currentSubPage.indexOf("commands")==0)){

                //click level, already handled
                return 

            }
        
            if(currentSubPage!="grid" && currentSubPage!="options" && currentSubPage!="mixer" && currentSubPage!=""){
            
                var finalMsg=paramName

                if(currentSubPage=="sends" || currentSubPage=="sends2" || currentSubPage.indexOf("mixersends")==0){
        
                    finalMsg=pluginName
        
                }
                    
                sendTextTwoLines(activeDevice,this.index,0,finalMsg)

            }

            if(currentSubPage=="fqc" || currentSubPage=="fqc2" || subPageShiftPreActivation=="fqc" || subPageShiftPreActivation=="fqc2"){
                
                updateDisplay(activeDevice,8,cText,1,pluginName,0,0,0,0)
                
            }
            
        }.bind({index})

       ourSurface.knobs[index].mSurfaceValue.mOnColorChange=function(activeDevice,r,g,b,a,isActive){
        
            var currentPage=activeDevice.getState("selectedPage")
            
            if(currentPage!=cV.constPageNameMixer){

                if(r==0 && g==0 && b==0){

                    r=g=b=1

                }
                
                var r127=Math.round(127*r)
                var g127=Math.round(127*g)
                var b127=Math.round(127*b)
            
                updateDisplay(activeDevice,this.index,cColor,1,"",r127,g127,b127,0)

                return 
            
            }

            var subPageShiftPreActivation=activeDevice.getState("subPageShiftPreActivation")     
           
            if(subPageShiftPreActivation=="grid" || subPageShiftPreActivation=="options"){

                return 
           
            }
            
            var subPageName=activeDevice.getState("subPageShift")
            if(subPageName=="grid" || subPageName=="shift" || subPageName=="shift2" || subPageName=="ctrl" || subPageName=="alt" || subPageName=="fn" || subPageName.indexOf("commands")==0 || subPageName=="options"){
                
                return 
            
            }
            
            var show=1
        
            if(isActive==false){
                
                show=0
            
            }
            
            var r127=Math.round(127*r)*show 
            var g127=Math.round(127*g)*show 
            var b127=Math.round(127*b)*show 
        
            updateDisplay(activeDevice,this.index,cColor,1,"",r127,g127,b127,0)    

        }.bind({index})

        ourSurface.buttonsFaders1[index].mSurfaceValue.mOnProcessValueChange=function(activeDevice,value){
        
            var currentPage=activeDevice.getState("selectedPage")
            
            if(currentPage==cV.constPageNameMixer){

                var subPageName=activeDevice.getState("buttonsAboveFaders")
                
                var rgbArr=cV.colorsPerSubPageButton1Faders[subPageName][0]
            
                var show=cV.channelsProperties[this.index].active 

                var ledObject=cV.leds.aboveFaders1[this.index]
                
                ledObject.r=rgbArr[0]*value*show 
                ledObject.g=rgbArr[1]*value*show 
                ledObject.b=rgbArr[2]*value*show 
            
                updateLed(activeDevice,ledObject) 
            }

        }.bind({index})
    
        ourSurface.buttonsFaders2[index].mSurfaceValue.mOnProcessValueChange=function(activeDevice,value){
            
            var currentPage=activeDevice.getState("selectedPage")
            
            if(currentPage==cV.constPageNameMixer){
                
                var subPageName=activeDevice.getState("buttonsAboveFaders")
                
                var rgbArr=cV.colorsPerSubPageButton1Faders[subPageName][1]
                var show=cV.channelsProperties[this.index].active 

                var ledObject=cV.leds.aboveFaders2[this.index]
                ledObject.r=rgbArr[0]*value*show 
                ledObject.g=rgbArr[1]*value*show 
                ledObject.b=rgbArr[2]*value*show 
            
                updateLed(activeDevice,ledObject) 
            }
        
        }.bind({index})

    }

    var ourStateControls={shift: ourSurface.buttons.shift,grid: ourSurface.buttons.grid,options: ourSurface.buttons.options}

    var stateKeys=Object.keys(ourStateControls)
    
    stateKeys.forEach(function(stateKey){

        var stateControl=ourStateControls[stateKey]

        stateControl.mSurfaceValue.mOnProcessValueChange=function(activeDevice,value){

            if(activeDevice.getState("stateSelected")!="" && activeDevice.getState("stateSelected")!=this.stateKey){

                return 

            }

            if(value>0){
                
                if(this.stateKey=="shift" && activeDevice.getState("subPageShift")=="inserts"){
                
                    ourSurface.custom["shiftArrows"].setProcessValue(activeDevice,1)
                
                } else {

                    ourSurface.custom[this.stateKey].setProcessValue(activeDevice,1)

                    activeDevice.setState("stateSelected",this.stateKey)
                
                }
            
            } else {

                if(this.stateKey=="shift" && activeDevice.getState("subPageShift")=="inserts"){
                
                    ourSurface.custom["shiftArrowsUp"].setProcessValue(activeDevice,1)
                
                } else {
            
                    ourSurface.custom.statesOff.setProcessValue(activeDevice,1-ourSurface.custom.statesOff.getProcessValue(activeDevice))

                    ourSurface.custom[this.stateKey].setProcessValue(activeDevice,0)

                    activeDevice.setState("stateSelected","")
               
                }
            
            }
        
        }.bind({stateKey})

    })

    //generic remote handlers for punchOut, precount, midi record mode, midi cycle record mode, and punchIn (this one comes from the MCU)
    if(generalSettings.strippedDownVersion==0){

        ourSurface.genericRemote.punchInFromLoopMidi.mOnProcessValueChange=function(activeDevice,value){

            activeDevice.setState("punchIn",""+value)
    
            if(isSubPageSelected(activeDevice,"options") && activeDevice.getState("selectedPage")==cV.constPageNameMixer){
    
                var ledObject=cV.leds.underDisplay[6]
                ledObject.r=127*value 
                ledObject.g=0 
                ledObject.b=0
                updateLed(activeDevice,ledObject) 
                
            }

            var notification="Punch In "
            if(value==0){
                notification=notification+"OFF"
            } else {

                notification=notification+"ON"
            }
            notify(activeDevice,["GR Received",notification])

            updatePunchInState(activeDevice)
    
        }

        ourSurface.genericRemote.punchOutFromLoopMidi.mOnProcessValueChange=function(activeDevice,value){

            activeDevice.setState("punchOut",""+value)
    
            if(isSubPageSelected(activeDevice,"options") && activeDevice.getState("selectedPage")==cV.constPageNameMixer){
    
                var ledObject=cV.leds.underDisplay[7]
                ledObject.r=0 
                ledObject.g=127*value 
                ledObject.b=0
                updateLed(activeDevice,ledObject) 
                
            }

            var notification="Punch Out "
            if(value==0){
                notification=notification+"OFF"
            } else {

                notification=notification+"ON"
            }
            notify(activeDevice,["GR Received",notification])

            updatePunchOutState(activeDevice)
    
        }
    
        ourSurface.genericRemote.midiRecordModeFromLoopMidi.mOnProcessValueChange=function(activeDevice,value,diff){
           
            var midiRecordMode=""
            
            if(value==0){
            
                midiRecordMode="New Parts"
            
            } else if (value==1){

                midiRecordMode="Replace"
            
            } else {
            
                //somewhere near 0.50
                midiRecordMode="Merge"
            
            }

            notify(activeDevice,["Midi Record Mode",midiRecordMode])
            activeDevice.setState("midiRecordMode",midiRecordMode)

            if(cV.subPagesForDawInfoDisplay.indexOf(activeDevice.getState("subPageShift"))!=-1){

                
                updateDisplay(activeDevice,3,cText,1,midiRecordMode,0,0,0,0)
            
            } else if (activeDevice.getState("subPageShift")=="options"){

                
                updateDisplay(activeDevice,3,cText,3,midiRecordMode,0,0,0,0)

            }

        }
    
        ourSurface.genericRemote.midiRecordCycleModeFromLoopMidi.mOnProcessValueChange=function(activeDevice,value,diff){
    
            var arg2Int=Math.floor(100*value)
            
            var midiRecordCycleMode=""
            
            if(arg2Int==0){
                midiRecordCycleMode="Mix"
            } else if (arg2Int==24){
                midiRecordCycleMode="Overwrite"
            } else if(arg2Int==49){
                midiRecordCycleMode="Keep Last"
            } else if (arg2Int==74){
                midiRecordCycleMode="Stacked"
            } else {
                // 100
                midiRecordCycleMode="Mix-Stacked"
            }

            notify(activeDevice,["Midi Cycle Record",midiRecordCycleMode])
            activeDevice.setState("midiCycleRecordMode",midiRecordCycleMode)

            if(cV.subPagesForDawInfoDisplay.indexOf(activeDevice.getState("subPageShift"))!=1){

                updateDisplay(activeDevice,4,cText,1,midiRecordCycleMode,0,0,0,0)
            
            } else if (activeDevice.getState("subPageShift")=="options"){

                updateDisplay(activeDevice,4,cText,3,midiRecordCycleMode,0,0,0,0)

            }

        }

        ourSurface.genericRemote.metronomePrecountFromLoopMidi.mOnProcessValueChange=function(activeDevice,value,diff){

            var preCount="OFF"

            if(value==1){
                
                preCount="ON"

            }

            notify(activeDevice,["Metronome","Precount "+preCount])
            activeDevice.setState("precount",preCount)
            
        }

    }
    
}

function makePageMixer(){
    
    var page=makePageWithDefaults(cV.constPageNameMixer)

	page.makeCommandBinding(ourSurface.pads[15].mSurfaceValue,'Edit', 'Edit VST Instrument')

    page.makeCommandBinding(ourSurface.pads[14].mSurfaceValue,'Edit', 'Edit Channel Settings')

    page.makeCommandBinding(ourSurface.pads[13].mSurfaceValue,'Devices', 'Mixer')
	
    
    var dummyTapTempoHostValue=page.mCustom.makeHostValueVariable("dummyTapTempo")
    
    page.makeValueBinding(ourSurface.pads[7].mSurfaceValue,dummyTapTempoHostValue).mOnValueChange=function(activeDevice,activeMapping,value,diff){
       
        if(value>0 && (value==diff || diff==0)){
            
            Helper_tapTempo(activeDevice,activeMapping,page)
        
        }
    
    }

    var allSubPages={

        mixer: {dispName: "Mixer",control: ourSurface.pads[0].mSurfaceValue,color: [127,0,0],led: cV.leds.pads[0],consumeKnobs: false, consumeLRKnobs: true,section: "mixer"},

        mixerpregain: {dispName: "Pregain",control: 0,color: [127,0,0],led: 0,consumeKnobs: false, consumeLRKnobs: true,section: "mixer",buttonHeaders: ["Bypass","Bypass","Bypass","Bypass","Bypass","Bypass","Bypass","Bypass"]},

        mixersends1: {dispName: "Sends 1",control: 0,color: [127,0,0],consumeKnobs: false, consumeLRKnobs: true,section: "mixer",
        buttonHeaders: ["Enable","Enable","Enable","Enable","Enable","Enable","Enable","Enable"]},

        mixersends2: {dispName: "Sends 2",control: 0,color: [127,0,0],consumeKnobs: false, consumeLRKnobs: true,section: "mixer",
        buttonHeaders: ["Enable","Enable","Enable","Enable","Enable","Enable","Enable","Enable"]},

        mixersends3: {dispName: "Sends 3",control: 0,color: [127,0,0],consumeKnobs: false, consumeLRKnobs: true,section: "mixer",buttonHeaders: ["Enable","Enable","Enable","Enable","Enable","Enable","Enable","Enable"]},

        mixersends4: {dispName: "Sends 4",control: 0,color: [127,0,0],consumeKnobs: false, consumeLRKnobs: true,section: "mixer",buttonHeaders: ["Enable","Enable","Enable","Enable","Enable","Enable","Enable","Enable"]},

        mixersends5: {dispName: "Sends 5",control: 0,color: [127,0,0],consumeKnobs: false, consumeLRKnobs: true,section: "mixer",buttonHeaders: ["Enable","Enable","Enable","Enable","Enable","Enable","Enable","Enable"]},

        mixersends6: {dispName: "Sends 6",control: 0,color: [127,0,0],consumeKnobs: false, consumeLRKnobs: true,section: "mixer",buttonHeaders: ["Enable","Enable","Enable","Enable","Enable","Enable","Enable","Enable"]},

        mixersends7: {dispName: "Sends 7",control: 0,color: [127,0,0],consumeKnobs: false, consumeLRKnobs: true,section: "mixer",buttonHeaders: ["Enable","Enable","Enable","Enable","Enable","Enable","Enable","Enable"]},

        mixersends8: {dispName: "Sends 8",control: 0,color: [127,0,0],consumeKnobs: false, consumeLRKnobs: true,section: "mixer",buttonHeaders: ["Enable","Enable","Enable","Enable","Enable","Enable","Enable","Enable"]},

        fqc: {dispName: "In Focus",control: ourSurface.pads[1].mSurfaceValue,color: [0,127,0],led: cV.leds.pads[1],consumeKnobs: false, consumeLRKnobs: true,section: "fqc"},

        fqc2: {dispName: "Knob AI",control: 0,color: [0,127,0],consumeKnobs: false, consumeLRKnobs: true,section: "fqc",buttonHeaders: ["Lock","","","","","","",""]},

        qc: {dispName: "Instr. QC",control: ourSurface.pads[2].mSurfaceValue,color: [0,0,127],led: cV.leds.pads[2],consumeKnobs: false, consumeLRKnobs: true,section: "qc",
        buttonHeaders: ["Pr.Browse","Sn.Browse","Nav.Right","Toggle","New Track","Track Pr.","Nav Up","Nav Down"]},

        pregain: {dispName: "Pregain",control: ourSurface.pads[3].mSurfaceValue,color: [127,127,0],led: cV.leds.pads[3],consumeKnobs: false, consumeLRKnobs: true,section: "pregain",
        buttonHeaders: ["Bypass","Low Cut","Hi Cut","","","","",""]},

        inserts: {dispName: "Inserts",control: ourSurface.pads[4].mSurfaceValue,color: [127,0,127],led: cV.leds.pads[4],consumeKnobs: false, consumeLRKnobs: true,section: "inserts",
        buttonHeaders: ["ON","Bypass","Read","Write","Edit","ShowH All","Close All",""]},

        eq: {dispName: "Equalizer",control: ourSurface.pads[5].mSurfaceValue,color: [0,127,127],led: cV.leds.pads[5],consumeKnobs: false, consumeLRKnobs: true,section: "eq",buttonHeaders: ["Enabled","Enabled","Enabled","Enabled","Enabled","Enabled","Enabled","Enabled"]},

        eq2: {dispName: "EQ Type/Q",control: 0,color: [0,127,127],led: cV.leds.pads[5],consumeKnobs: false, consumeLRKnobs: true,section: "eq",buttonHeaders: ["Enabled","Enabled","Enabled","Enabled","Enabled","Enabled","Enabled","Enabled"]},

        gate: {dispName: "Gate",control: 0,color: [127,0,127],led: cV.leds.pads[5],consumeKnobs: false, consumeLRKnobs: true,section: "eq",
        buttonHeaders: ["On","Bypass","Read","Write","","","",""]},

        comp: {dispName: "Compress",control: 0,color: [127,127,127],led: cV.leds.pads[5],consumeKnobs: false, consumeLRKnobs: true,section: "eq",
        buttonHeaders: ["On","Bypass","Read","Write","","","",""]},

        tools: {dispName: "Tools",control: 0,color: [127,127,127],led: cV.leds.pads[5],consumeKnobs: false, consumeLRKnobs: true,section: "eq",
        buttonHeaders: ["On","Bypass","Read","Write","","","",""]},

        sat: {dispName: "Saturator",control: 0,color: [127,127,127],led: cV.leds.pads[5],consumeKnobs: false, consumeLRKnobs: true,section: "eq",
        buttonHeaders: ["On","Bypass","Read","Write","","","",""]},

        limit: {dispName: "Limiter",control: 0,color: [127,127,127],led: cV.leds.pads[5],consumeKnobs: false, consumeLRKnobs: true,section: "eq",
        buttonHeaders: ["On","Bypass","Read","Write","","","",""]},

        sends: {dispName: "Sends",control: ourSurface.pads[6].mSurfaceValue,color: [127,127,127],led: cV.leds.pads[6],consumeKnobs: false, consumeLRKnobs: true,section: "sends",
        buttonHeaders:["Enable","Enable","Enable","Enable","Enable","Enable","Enable","Enable"]},

        sends2: {dispName: "SendsPost",control: 0,color: [127,127,127],led: cV.leds.pads[6],consumeKnobs: false, consumeLRKnobs: true,section: "sends",
        buttonHeaders: ["Post","Post","Post","Post","Post","Post","Post","Post"]},

        commands1: {dispName: "Com.Set 1",control: ourSurface.pads[12].mSurfaceValue,color: [80,80,80],led: cV.leds.pads[12],consumeKnobs: true, consumeLRKnobs: false,section: "commands1"},

        commands2: {dispName: "Com.Set 2",control: 0,color: [80,80,80],led: cV.leds.pads[12],consumeKnobs: true, consumeLRKnobs: false,section: "commands1"},

        commands3: {dispName: "Com.Set 3",control:0,color: [80,80,80],led: cV.leds.pads[12],consumeKnobs: true, consumeLRKnobs: false,section: "commands1"},

        commands4: {dispName: "Com.Set 4",control: 0,color: [80,80,80],led: cV.leds.pads[12],consumeKnobs: true, consumeLRKnobs: false,section: "commands1"},

        commands5: {dispName: "Com.Set 5",control: 0,color: [80,80,80],led: cV.leds.pads[12],consumeKnobs: true, consumeLRKnobs: false,section: "commands1"},

        shift: {dispName: "Shift",control: ourSurface.custom.shift,color: [127,127,127],led: 0,consumeKnobs: true, consumeLRKnobs: false},

        shift2: {dispName: "Shift 2",control: ourSurface.custom.shift2,color: [80,0,0],led: cV.leds.pads[8],consumeKnobs: true, consumeLRKnobs: false},

        ctrl: {dispName: "Ctrl",control: ourSurface.custom.ctrl,color: [0,80,0],led: cV.leds.pads[9],consumeKnobs: true, consumeLRKnobs: false},

        alt: {dispName: "Alt",control: ourSurface.custom.alt,color: [0,0,80],led: cV.leds.pads[10],consumeKnobs: true, consumeLRKnobs: false},

        fn: {dispName: "FN",control: ourSurface.custom.fn,color: [80,80,80],led: cV.leds.pads[11],consumeKnobs: true, consumeLRKnobs: false},

        grid: {dispName: "Grid",control: ourSurface.custom.grid,color: [127,127,127],led: cV.leds.grid,consumeKnobs: true, consumeLRKnobs: false},

        options: {dispName: "Options",control: ourSurface.custom.options,color: [127,127,127],led: cV.leds.options,consumeKnobs: false, consumeLRKnobs: true}
    
    }

    var dummyVarToConsumeControls=page.mCustom.makeHostValueVariable("dummyToConsume")
    
    var subPagesObj=makeSubPages(page,"subPageShift",0,allSubPages)

    var subPagesShiftArea=subPagesObj[0]
    
    var subPages=subPagesObj[1]
    
    var subPagesSections=subPagesObj[2]

    var mappedSubPagesToBigArrows=subPagesObj[3]

    //---------------

    var subPagesKeys=Object.keys(allSubPages)
    
    subPagesKeys.forEach(function(subPageName){
    
        var control=allSubPages[subPageName].control 
    
        if (typeof control !="number"){
            
            page.makeActionBinding(control,subPages[subPageName].mAction.mActivate).mOnValueChange=function(activeDevice,activeMapping,value,diff){
                
                activeDevice.setState("subPageShiftPreActivation",this.subPageName)
                
            }.bind({subPageName})

            page.makeValueBinding(control,dummyVarToConsumeControls).setSubPage(subPages[subPageName])
        
        }
    
    })

    //deactivating subpages of states
    var dummyDeactivateState=page.mCustom.makeHostValueVariable("dummyDeactivateState")

    page.makeValueBinding(ourSurface.custom.statesOff,dummyDeactivateState).mOnValueChange=function(activeDevice,activeMapping,value){

        var subPageToRetrieveName=activeDevice.getState("subPageShiftprev")
        var subPageToRetrieve=this.subPages[subPageToRetrieveName]

        subPageToRetrieve.mAction.mActivate.trigger(activeMapping)
        
        activeDevice.setState("subPageShiftPreActivation",subPageToRetrieveName)
        

    }.bind({subPages})

    var dummyInitialValue=page.mCustom.makeHostValueVariable("dummyInitialValue")

    var otherShiftStates=["shift2","ctrl","alt","fn"]
    for(var dummyPadIndex=0;dummyPadIndex<4;dummyPadIndex++){
        
        page.makeValueBinding(ourSurface.pads[dummyPadIndex+8].mSurfaceValue,dummyInitialValue).mOnValueChange=function(activeDevice,activeMapping,value,diff){

            if(activeDevice.getState("stateSelected")!="" && activeDevice.getState("stateSelected")!=this.otherShiftStates[this.dummyPadIndex]){

                return 

            }

            if(value>0){

                ourSurface.custom[this.otherShiftStates[this.dummyPadIndex]].setProcessValue(activeDevice,1)

                activeDevice.setState("stateSelected",this.otherShiftStates[this.dummyPadIndex])

            } else {
    
                ourSurface.custom.statesOff.setProcessValue(activeDevice,1-ourSurface.custom.statesOff.getProcessValue(activeDevice))
                
                activeDevice.setState("stateSelected","")
            
            }
        
            
        }.bind({dummyPadIndex,otherShiftStates})
    
    }
    
    var dummySubPageMappedUp=page.mCustom.makeHostValueVariable("dummySubPageMappedUp")
    
    page.makeValueBinding(ourSurface.buttons.arrowUpPads.mSurfaceValue,dummySubPageMappedUp).mOnValueChange=function(activeDevice,activeMapping,value){

        if(value==1){

            changeSubPage(activeDevice,activeMapping,1)

        }

    }

    var dummySubPageMappedDn=page.mCustom.makeHostValueVariable("dummySubPageMappedDn")
    
    page.makeValueBinding(ourSurface.buttons.arrowDnPads.mSurfaceValue,dummySubPageMappedDn).mOnValueChange=function(activeDevice,activeMapping,value){

        if(value==1){

            changeSubPage(activeDevice,activeMapping,-1)

        }

    }

    function changeSubPage(activeDevice,activeMapping,incDec){

        var mappedSubPageIndex=activeDevice.getState("mappedSubPageIndex")
        if(mappedSubPageIndex==""){
    
            mappedSubPageIndex="0"
    
        }

        var mappedSubPageIndexInt=parseInt(mappedSubPageIndex)

        mappedSubPageIndexInt=mappedSubPageIndexInt+incDec
    
        if(mappedSubPageIndexInt==mappedSubPagesToBigArrows.length){
    
            mappedSubPageIndexInt=0
    
        } else if (mappedSubPageIndexInt==-1){
            
            mappedSubPageIndexInt=mappedSubPagesToBigArrows.length-1

        }
        
        subPages[mappedSubPagesToBigArrows[mappedSubPageIndexInt]].mAction.mActivate.trigger(activeMapping)
        activeDevice.setState("subPageShiftPreActivation",mappedSubPagesToBigArrows[mappedSubPageIndexInt])
        
        activeDevice.setState("mappedSubPageIndex",mappedSubPageIndexInt.toString())

    }
    
    //mapping little up/down arrows to subpages of sections
    var dummyArrowUpDn=page.mCustom.makeHostValueVariable("dummyArrowUpDn")

    Object.keys(subPagesSections).forEach(function(subPagesSection){
    
        var subPagesOfSection=subPagesSections[subPagesSection]
        var sectionSize=subPagesOfSection.length 
        
        if(sectionSize>1){
            
            for(var subPageIndex=0;subPageIndex<sectionSize;subPageIndex++){

                var previouSubPageIndex=subPageIndex>0 ? subPageIndex-1 : sectionSize-1
                var previousSubPage=subPagesOfSection[previouSubPageIndex]
    
                var nextSubPageIndex=subPageIndex==sectionSize-1 ? 0 : subPageIndex+1
                var nextSubPage=subPagesOfSection[nextSubPageIndex]
                
                var currentSubPage=subPagesOfSection[subPageIndex]
    
                page.makeActionBinding(ourSurface.buttons.arrowUpScreen.mSurfaceValue,subPages[nextSubPage].mAction.mActivate).setSubPage(subPages[currentSubPage])
    
                page.makeActionBinding(ourSurface.buttons.arrowDnScreen.mSurfaceValue,subPages[previousSubPage].mAction.mActivate).setSubPage(subPages[currentSubPage])
            
            }

        } else {
                
            var currentSubPage=subPagesOfSection[0]
            
            if(currentSubPage!="inserts" && currentSubPage!="qc"){
                    
                page.makeValueBinding(ourSurface.buttons.arrowUpScreen.mSurfaceValue,dummyArrowUpDn).setSubPage(subPages[currentSubPage])

                page.makeValueBinding(ourSurface.buttons.arrowDnScreen.mSurfaceValue,dummyArrowUpDn).setSubPage(subPages[currentSubPage])

            }
                
        }
           
    })
    
    var bindingsIndexed={}

    for(var i=0;i<8;i++){
    
        var i1=i+1
        var padName="pad"+i1
        bindingsIndexed[padName]=ourSurface.pads[i].mSurfaceValue
        
        var i2=8+i 
        var i3=i2+1
        var padName2="pad"+i3
        bindingsIndexed[padName2]=ourSurface.pads[i2].mSurfaceValue

        var knobLeftName="knobLeft"+i1  
        bindingsIndexed[knobLeftName]=ourSurface.knobsLeft[i]

        var knobRightName="knobRight"+i1 
        bindingsIndexed[knobRightName]=ourSurface.knobsRight[i]

        var buttonName="button"+i1 
        bindingsIndexed[buttonName]=ourSurface.buttonsScreen[i].mSurfaceValue

    }
    
    var nonArrayControls=["duplicate","clear","rewind","forward","stop","play","loop","record","arrowRightA","arrowRightB"]
    var bindingsKeys=Object.keys(bindings)

    var stateArraysToCommandArrays={shift:"commands1",shift2:"commands2",ctrl:"commands3",alt:"commands4",fn:"commands5"}

    bindingsKeys.forEach(function(key){
    
        var commandArray=bindings[key]
        var controlNameArr=key.split("With")
        var controlName=controlNameArr[0]
        var subPageName=""
        var subPageNameCommands=""
        
        if(controlNameArr.length>1){

            subPageName=controlNameArr[1].toLowerCase()

            subPageNameCommands=stateArraysToCommandArrays[subPageName]

        }
        
        var commandCategory=commandArray[0]
        if(commandCategory!="Custom"){

            var commandName=commandArray[1]
            var commandShortName=commandArray[2]
        
            var rgb=[]

            if(commandArray.length>3){
        
                rgb=commandArray[3]
        
            } else {

                rgb=[127,127,127]
            
            }
 
            var bindingToCommands=false 

            var commandRepeat=0
            if(commandArray.length>4){
                var tempRepeat=commandArray[4]
                if(tempRepeat.toLowerCase()=="repeat"){

                    commandRepeat=1
                
                }
            
            }
            
            if (nonArrayControls.indexOf(controlName)>-1){
                
                if(["duplicate","clear","arrowRightA","arrowRightB"].indexOf(controlName)!=-1 && subPageName==""){
                    
                    //setting default colors here
                    cV.leds[controlName].r=rgb[0]
                    cV.leds[controlName].g=rgb[1]
                    cV.leds[controlName].b=rgb[2]
                
                }

                var nonArrayControl=ourSurface.buttons[controlName]
                var controlSurfaceValue=nonArrayControl.mSurfaceValue
                

                localMakeCommand(controlSurfaceValue,commandCategory,commandName,subPageName,commandRepeat)
                    
            } else {
              
                var control2=bindingsIndexed[controlName]
                localMakeCommand(control2,commandCategory,commandName,subPageName,commandRepeat)
                if(subPageName!=""){
              
                    if(subPageNameCommands!=undefined && subPageNameCommands!="" && (controlName.indexOf("knobLeft")!=-1 || controlName.indexOf("knobRight")!=-1 || controlName.indexOf("button")!=-1)){
                        
                        localMakeCommand(control2,commandCategory,commandName,subPageNameCommands,commandRepeat)
                        
                        bindingToCommands=true 
                    
                    }
                }
                
            }
       
            if(!(subPageName in bindingsDisplayMap)){
                    
                bindingsDisplayMap[subPageName]={}

            }

            if(!(subPageNameCommands in bindingsDisplayMap) && bindingToCommands==true){

                bindingsDisplayMap[subPageNameCommands]={}

            }

            var controlPrefix=controlName.replace(/[0-9]/g, '')
            var controlIndex=-1
            
            if(controlName!=controlPrefix){
            
                controlIndex=parseInt(controlName.substring(controlPrefix.length))-1 
            
            }
            
            var bindingsDisplayMapPerControlType=bindingsDisplayMap[subPageName]
            
            if(!(controlPrefix in bindingsDisplayMapPerControlType)){

                bindingsDisplayMapPerControlType[controlPrefix]={}
            
            }
            
            bindingsDisplayMapPerControlType[controlPrefix][controlIndex]=[commandShortName,rgb]

            if(bindingToCommands==true){

                var bindingsDisplayMapPerControlType=bindingsDisplayMap[subPageNameCommands]
                
                if(!(controlPrefix in bindingsDisplayMapPerControlType)){

                    bindingsDisplayMapPerControlType[controlPrefix]={}
                    
                }
            
                bindingsDisplayMapPerControlType[controlPrefix][controlIndex]=[commandShortName,rgb]
            
            }

        } else {

            //custom binding 
            var commandShortName=commandArray[2]
        
            var rgb=[]

            if(commandArray.length>3){
        
                rgb=commandArray[3]
        
            } else {

                rgb=[127,127,127]
            
            }

            var controlPrefix=controlName.replace(/[0-9]/g, '')
            var controlIndex=-1
            
            if(controlName!=controlPrefix){
            
                controlIndex=parseInt(controlName.substring(controlPrefix.length))-1 
            
            }


            var bindingsDisplayMapPerControlType=bindingsDisplayMap[subPageName]

            bindingsDisplayMapPerControlType[controlPrefix][controlIndex]=[commandShortName,rgb]

            var bindingsDisplayMapPerControlType=bindingsDisplayMap[subPageNameCommands]
                
            if(!(controlPrefix in bindingsDisplayMapPerControlType)){

                    bindingsDisplayMapPerControlType[controlPrefix]={}
                    
            }
            
            bindingsDisplayMapPerControlType[controlPrefix][controlIndex]=[commandShortName,rgb]



        }

    })

    var displayArrowsSubPageArea=page.makeSubPageArea("displayArrowsSubPageArea")

    var subPageDisplayArrowsDefault=displayArrowsSubPageArea.makeSubPage("subPageDisplayArrowsDefault")
    var subPageDisplayArrowsShift=displayArrowsSubPageArea.makeSubPage("subPageDisplayArrowsShift")
    
    var subPagesAboveFaders={
    
        muteSolo: {dispName: "Mute-Solo",control: 0,color: [127,0,0],led: 0,consumeKnobs: false, consumeLRKnobs: true},

        readWrite: {dispName: "Read-Write",control: 0,color: [127,0,0],led: 0,consumeKnobs: false, consumeLRKnobs: true},

        monitorDefeat: {dispName: "Monitor-S.Defeat",control: 0,color: [127,0,0],led: 0,consumeKnobs: false, consumeLRKnobs: true},

        armSelect: {dispName: "Arm-Select",control: 0,color: [127,0,0],led: 0,consumeKnobs: false, consumeLRKnobs: true}
    
    }

    var subPagesButtonsAboveFadersArr=makeSubPages(page,"buttonsAboveFaders",1,subPagesAboveFaders)

    var subPagesButtonsAboveFadersArea=subPagesButtonsAboveFadersArr[0]
    var subPagesButtonsAboveFaders=subPagesButtonsAboveFadersArr[1]

    page.makeActionBinding(ourSurface.buttons.arrowUpRight.mSurfaceValue,subPagesButtonsAboveFadersArea.mAction.mNext)

    page.makeActionBinding(ourSurface.buttons.arrowDnRight.mSurfaceValue,subPagesButtonsAboveFadersArea.mAction.mPrev)

    var dummyRightArrowUp=page.mCustom.makeHostValueVariable("dummyRightArrowUp")

    page.makeValueBinding(ourSurface.buttons.arrowUpRight.mSurfaceValue,dummyRightArrowUp).setSubPage(subPages["options"]).mOnValueChange=function(activeDevice,activeMapping,value,diff){

        if(value==1){

            var subPageNameFaders=activeDevice.getState("buttonsAboveFaders")
            if(subPageNameFaders==""){

                subPageNameFaders="muteSolo"
            }

            switch (subPageNameFaders){

                case "muteSolo":

                    ourSurface.custom.unumuteAll.setProcessValue(activeDevice,1)
                    break

                case "readWrite":

                    ourSurface.custom.readAutoAll.setProcessValue(activeDevice,1)
                    break 

                case "armSelect":

                    ourSurface.custom.armAllAudio.setProcessValue(activeDevice,1)
                    break 
            
            } 
            
        }
    
    }

    var dummyRightArrowDn=page.mCustom.makeHostValueVariable("dummyRightArrowDn")

    page.makeValueBinding(ourSurface.buttons.arrowDnRight.mSurfaceValue,dummyRightArrowDn).setSubPage(subPages["options"]).mOnValueChange=function(activeDevice,activeMapping,value,diff){

        if(value==1){

            var subPageNameFaders=activeDevice.getState("buttonsAboveFaders")
            if(subPageNameFaders==""){

                subPageNameFaders="muteSolo"
            }

            switch (subPageNameFaders){

                case "muteSolo":

                    ourSurface.custom.deactivateAllSolo.setProcessValue(activeDevice,1)
                    break

                case "readWrite":

                    ourSurface.custom.writeAutoAll.setProcessValue(activeDevice,1)
                    break 

                case "armSelect":

                    ourSurface.custom.disarmAllAudio.setProcessValue(activeDevice,1)
                    break 
            
            } 
            
        }
    
    }

    page.makeCommandBinding(ourSurface.custom.deactivateAllSolo,'Edit', 'Deactivate All Solo')

    page.makeCommandBinding(ourSurface.custom.unumuteAll,'Edit', 'Unmute All')

    page.makeCommandBinding(ourSurface.custom.readAutoAll,'Automation', 'Toggle Read Enable All Tracks')

    page.makeCommandBinding(ourSurface.custom.writeAutoAll,'Automation', 'Toggle Write Enable All Tracks')

    page.makeCommandBinding(ourSurface.custom.armAllAudio,'Mixer', 'Arm All Audio Tracks')

    page.makeCommandBinding(ourSurface.custom.disarmAllAudio,'Mixer', 'Disarm All Audio Tracks')



    var mixerBankZone=page.mHostAccess.mMixConsole.makeMixerBankZone("main")

    if(generalSettings.mixerExcludeInputChannels==1){

        mixerBankZone.excludeInputChannels()

    }
    
    if(generalSettings.mixerExcludeOutputChannels==1){

        mixerBankZone.excludeOutputChannels()

    }
    
    if(generalSettings.mixerFollowVisibility==1){
        
        mixerBankZone.setFollowVisibility(true)
    
    }

    var mixerChannel=page.mHostAccess.mTrackSelection.mMixerChannel

    var instrumentBankZone=mixerChannel.mInstrumentPluginSlot.mParameterBankZone

    mixerChannel.mInstrumentPluginSlot.mOnChangePluginIdentity=function(activeDevice,activeMapping,pluginName,pluginVendor){

        var currentSubPageName=activeDevice.getState("subPageShift")
        if(currentSubPageName=="qc"){

            updateKnobsWhenInChangePluginIdentity(activeDevice,false,true)

            updateDisplay(activeDevice,8,cText,1,pluginName,0,0,0,0)
        }

    }
    
    page.makeActionBinding(ourSurface.buttons.arrowUpScreen.mSurfaceValue,instrumentBankZone.mAction.mNextBank).setSubPage(subPages["qc"])
    page.makeActionBinding(ourSurface.buttons.arrowDnScreen.mSurfaceValue,instrumentBankZone.mAction.mPrevBank).setSubPage(subPages["qc"])
    
    
    var insertsViewer=mixerChannel.mInsertAndStripEffects.makeInsertEffectViewer("insertsViewer")
    
    insertsViewer.followPluginWindowInFocus()
    
    insertsViewer.mOnTitleChange=(function(activeDevice,activeMapping,arg2){
       
        var tempInsertName=activeDevice.getState("tempInsertName")
        
        var insertNameVar="insertname"+arg2 
        
        activeDevice.setState(insertNameVar,tempInsertName)

        activeDevice.setState("insertindex",arg2)

        if(activeDevice.getState("subPageShift")=="inserts"){

            updateDisplay(activeDevice,8,cText,0,"Slot "+arg2)

        }
        
    })

    insertsViewer.mOnChangePluginIdentity=function(activeDevice,activeMapping,pluginName,pluginVendor,pluginVersion,vstType){
        

        activeDevice.setState("tempInsertName",pluginName)
        //mOnChangePluginIdentity fires before the mOnTitle which gives the slot's index. We're setting here the name so that we can correctly assign it to its state

        var subPageName=activeDevice.getState("subPageShift")
       
        if(subPageName=="inserts" || subPageName=="grid"){

            updateDisplay(activeDevice,8,cText,1,pluginName)

            updateKnobsWhenInChangePluginIdentity(activeDevice,false,true)
        
        } else {

           activeDevice.setState("insertName",pluginName)
        
        }

    }


    page.makeActionBinding(ourSurface.buttons.arrowUpScreen.mSurfaceValue,insertsViewer.mAction.mNext).setSubPage(subPages["inserts"]).mOnValueChange=function(activeDevice,activeMapping,value,diff){
    
        insertsViewer.mParameterBankZone.mAction.mResetBank.trigger(activeMapping)
    
    }

    page.makeActionBinding(ourSurface.buttons.arrowDnScreen.mSurfaceValue,insertsViewer.mAction.mPrev).setSubPage(subPages["inserts"]).mOnValueChange=function(activeDevice,activeMapping,value,diff){
    
        insertsViewer.mParameterBankZone.mAction.mResetBank.trigger(activeMapping)
    
    }

    var fqc2Params=[

        page.mHostAccess.mMouseCursor.mValueUnderMouse,dummyVarToConsumeControls,dummyVarToConsumeControls,dummyVarToConsumeControls,dummyVarToConsumeControls,dummyVarToConsumeControls,dummyVarToConsumeControls,dummyVarToConsumeControls,

        page.mHostAccess.mMouseCursor.mValueLocked,
        dummyVarToConsumeControls,dummyVarToConsumeControls,dummyVarToConsumeControls,dummyVarToConsumeControls,dummyVarToConsumeControls,dummyVarToConsumeControls,dummyVarToConsumeControls
    
    ]

    var qcButtons=[
    
        "Preset,Open Browser",
        "Media,Open Sound Browser",
        "Navigate,Right,repeat",
        "Navigate,Toggle Selection",
        "Media,Create Track",
        "AddTrack,From Track Presets",
        "Navigate,Up,repeat",
        "Navigate,Down,repeat"
    
    ]

    var pregain=mixerChannel.mPreFilter
    
    var preGainParams=[

        pregain.mGain,pregain.mPhaseSwitch,pregain.mLowCutFreq,pregain.mLowCutSlope,pregain.mHighCutFreq,pregain.mHighCutSlope,
        dummyVarToConsumeControls,dummyVarToConsumeControls,

        pregain.mBypass,pregain.mLowCutOn,pregain.mHighCutOn,dummyVarToConsumeControls,dummyVarToConsumeControls,dummyVarToConsumeControls,dummyVarToConsumeControls,dummyVarToConsumeControls,dummyVarToConsumeControls,dummyVarToConsumeControls,dummyVarToConsumeControls
    
    ]

    var insertsParamsButtons=[
        
        insertsViewer.mOn,insertsViewer.mBypass,insertsViewer.mAutomationRead,insertsViewer.mAutomationWrite,insertsViewer.mEdit,
        "Windows,Show/Hide Plug-ins","Windows,Close All Plug-in Windows",
        dummyVarToConsumeControls
    
    ]

    var insertsParamsZone=insertsViewer.mParameterBankZone

    page.makeActionBinding(ourSurface.custom.shiftArrows,subPageDisplayArrowsShift.mAction.mActivate).setSubPage(subPages["inserts"])

    page.makeActionBinding(ourSurface.custom.shiftArrowsUp,subPageDisplayArrowsDefault.mAction.mActivate).setSubPage(subPages["inserts"])

    page.makeActionBinding(ourSurface.buttons.arrowUpScreen.mSurfaceValue,insertsParamsZone.mAction.mNextBank).setSubPage(subPageDisplayArrowsShift)

    page.makeActionBinding(ourSurface.buttons.arrowDnScreen.mSurfaceValue,insertsParamsZone.mAction.mPrevBank).setSubPage(subPageDisplayArrowsShift)

    var eq=mixerChannel.mChannelEQ
    var eqBands=[eq.mBand1,eq.mBand2,eq.mBand3,eq.mBand4]
    var eqParams=[]
    var eq2Params=[]
    var eqParamsButtons=[]
    
    
    for(var eqBandIndex=0;eqBandIndex<4;eqBandIndex++){
    
        var eqBand=eqBands[eqBandIndex]
        eqParams.push(eqBand.mGain,eqBand.mFreq)
        eqParamsButtons.push(eqBand.mOn,eqBand.mOn)
        eq2Params.push(eqBand.mFilterType,eqBand.mQ)
        
    }

    var stripEffects=mixerChannel.mInsertAndStripEffects.mStripEffects
    
    
    var otherStripEffects=[stripEffects.mGate,stripEffects.mCompressor,stripEffects.mTools,stripEffects.mSaturator,stripEffects.mLimiter]
    
   
   
    var stripEffectsButtons=[]

    for(var otherStripEffectsIndex=0;otherStripEffectsIndex<otherStripEffects.length;otherStripEffectsIndex++){
    
        var stripEffect=otherStripEffects[otherStripEffectsIndex]
        stripEffectsButtons.push([stripEffect.mOn,stripEffect.mBypass,stripEffect.mAutomationRead,stripEffect.mAutomationWrite,dummyVarToConsumeControls,dummyVarToConsumeControls,dummyVarToConsumeControls,dummyVarToConsumeControls])


        stripEffect.mOnTitleChange=function(activeDevice,activeMapping,indexInStrip){

            activeDevice.setState("stripeffect"+this.otherStripEffectsIndex+"index",indexInStrip)

        }.bind({otherStripEffectsIndex})
        
        stripEffect.mOnChangePluginIdentity=function(activeDevice,activeMapping,pluginName,arg4,arg5){
            
            activeDevice.setState("strip"+this.otherStripEffectsIndex,pluginName)
            
            var subPageName=activeDevice.getState("subPageShift")
            
            if(subPageName==cV.stripSubPages[this.otherStripEffectsIndex] || subPageName=="grid"){

                updateDisplay(activeDevice,8,cText,1,pluginName,0,0,0,0)

                updateKnobsWhenInChangePluginIdentity(activeDevice,false,true)
                

            }

        }.bind({otherStripEffectsIndex})
    
    }
    
    var consumingKnobLeftRightSubPages=["mixer","mixerpregain","mixersends1","mixersends2","mixersends3","mixersends4","mixersends5","mixersends6","mixersends7","mixersends8","fqc","qc","pregain","inserts","eq","eq2","gate","comp","tools","sat","limit","sends","sends2","options"]

    for(var controlIndex=0;controlIndex<8;controlIndex++){
        
        var knob=ourSurface.knobs[controlIndex].mSurfaceValue
        var button=ourSurface.buttonsScreen[controlIndex].mSurfaceValue
        var fader=ourSurface.faders[controlIndex].mSurfaceValue
        
        //Mixer/Pan/Select
        var mixerBankZoneChannel=mixerBankZone.makeMixerBankChannel()
    
        var pan=mixerBankZoneChannel.mValue.mPan
        var volume=mixerBankZoneChannel.mValue.mVolume
        var selected=mixerBankZoneChannel.mValue.mSelected
        page.makeValueBinding(knob,pan).setSubPage(subPages["mixer"]).setValueTakeOverModeScaled()
        page.makeValueBinding(fader,volume).setValueTakeOverModePickup()

        page.makeValueBinding(button,selected).setSubPage(subPages["mixer"])

        page.makeValueBinding(ourSurface.dummy.buttonsSelect[controlIndex].mSurfaceValue,selected)


        mixerBankZoneChannel.mInstrumentPluginSlot.mOnChangePluginIdentity=function(activeDevice,activeMapping,pluginName){
           
            cV.channelsProperties[this.controlIndex].pluginName=pluginName
            
            
            var subPageName=activeDevice.getState("subPageShift")

            if(subPageName=="mixer" || subPageName=="" || subPageName=="grid"){
                
                if(generalSettings.display.pluginName==1){
                    
                    updateDisplay(activeDevice,this.controlIndex,cText,3,pluginName,0,0,0,0)

                }

            } else if (subPageName=="qc"){

                updateDisplay(activeDevice,8,cText,1,pluginName,0,0,0,0)
            
            }
        
        }.bind({controlIndex})

        volume.mOnDisplayValueChange=function(activeDevice,activeMapping,volumeDisplayValue){

            if(activeDevice.getState("pageSelected")==cV.constPageNameMixer){

                volumeDisplayValue=volumeDisplayValue!="" ? "V: "+volumeDisplayValue : volumeDisplayValue 
                cV.channelsProperties[this.controlIndex].volume=volumeDisplayValue

                var subPageName=activeDevice.getState("subPageShift")
                
                if(subPageName=="mixer" || subPageName==""){
            
                    updateDisplay(activeDevice,this.controlIndex,cText,1,volumeDisplayValue,0,0,0,0)
    
                }
            
            }
            
        }.bind({controlIndex})

        pan.mOnDisplayValueChange=function(activeDevice,activeMapping,panDisplayValue){
            
            if(activeDevice.getState("pageSelected")==cV.constPageNameMixer){

                cV.channelsProperties[this.controlIndex].pan=panDisplayValue 

                var subPageName=activeDevice.getState("subPageShift")
                
                if(subPageName=="mixer" || subPageName==""){
            
                    updateDisplay(activeDevice,this.controlIndex,cText,0,panDisplayValue,0,0,0,0)
        
                }
            
            }

        }.bind({controlIndex})

        pan.mOnProcessValueChange=function(activeDevice,activeMapping,panValue){

            if(activeDevice.getState("pageSelected")==cV.constPageNameMixer){
               
               var subPageName=activeDevice.getState("subPageShift")
                
                if(subPageName=="mixer" || subPageName==""){

                    updateDisplay(activeDevice,this.controlIndex,cValue,0,"",0,0,0,Math.round(panValue*127))

                }
            
            }

        }.bind({controlIndex})

      
        //Mixer/pregain
        var pregainGain=mixerBankZoneChannel.mPreFilter.mGain
        var pregainBypass=mixerBankZoneChannel.mPreFilter.mBypass
        
        page.makeValueBinding(knob,pregainGain).setSubPage(subPages["mixerpregain"])
        page.makeValueBinding(button,pregainBypass).setSubPage(subPages["mixerpregain"]).setTypeToggle()

        //Mixer/sends 
        for(var sendSlotIndex=0;sendSlotIndex<8;sendSlotIndex++){
        
            var sendSubPage="mixersends"+(sendSlotIndex+1).toString()
            var sendSlotLevel=mixerBankZoneChannel.mSends.getByIndex(sendSlotIndex)
        
            page.makeValueBinding(knob,sendSlotLevel.mLevel).setSubPage(subPages[sendSubPage])
            page.makeValueBinding(button,sendSlotLevel.mOn).setSubPage(subPages[sendSubPage]).setTypeToggle()

        }

        //Mixer/Solo-Mute,Read-Write,Arm-Select
        var solo=mixerBankZoneChannel.mValue.mSolo
        var mute=mixerBankZoneChannel.mValue.mMute

        var read=mixerBankZoneChannel.mValue.mAutomationRead
        var write=mixerBankZoneChannel.mValue.mAutomationWrite

        var recordArm=mixerBankZoneChannel.mValue.mRecordEnable

        var monitor=mixerBankZoneChannel.mValue.mMonitorEnable

        var button1=ourSurface.buttonsFaders1[controlIndex].mSurfaceValue
        var button2=ourSurface.buttonsFaders2[controlIndex].mSurfaceValue
        
        //Mute-Solo, Read-Write, Arm-Select, Monitor-Solo Defeat
        page.makeValueBinding(button1,mute).setSubPage(subPagesButtonsAboveFaders.muteSolo).setTypeToggle()

        page.makeValueBinding(button2,solo).setSubPage(subPagesButtonsAboveFaders.muteSolo).setTypeToggle()

        page.makeValueBinding(button1,read).setSubPage(subPagesButtonsAboveFaders.readWrite).setTypeToggle()

        page.makeValueBinding(button2,write).setSubPage(subPagesButtonsAboveFaders.readWrite).setTypeToggle()
        
        page.makeValueBinding(button1,recordArm).setSubPage(subPagesButtonsAboveFaders.armSelect).setTypeToggle()

        page.makeValueBinding(button2,selected).setSubPage(subPagesButtonsAboveFaders.armSelect).setTypeToggle()
        
        page.makeValueBinding(button1,monitor).setSubPage(subPagesButtonsAboveFaders.monitorDefeat).setTypeToggle()

        page.makeValueBinding(button2,selected).setSubPage(subPagesButtonsAboveFaders.monitorDefeat).mOnValueChange=function(activeDevice,activeMapping,value,diff){

            ourSurface.custom.soloDefeat.setProcessValue(activeDevice,1-ourSurface.custom.soloDefeat.getProcessValue(activeDevice))
        
        }

        //Focused Quick Controls 
        var fqcControl=page.mHostAccess.mFocusedQuickControls.getByIndex(controlIndex)
        
        page.makeValueBinding(knob,fqcControl).setSubPage(subPages["fqc"])
        page.makeValueBinding(button,dummyVarToConsumeControls).setSubPage(subPages["fqc"])

        fqcControl.mOnTitleChange=function(activeDevice,activeMapping,pluginName,paramName){
            //the mOnTitleChange of knobs in fqc does not seem to be triggered properly, while in this subPage and changing focused plugin
            //So, I had to add this 
            if(isSubPageSelected(activeDevice,"fqc")==true){

                sendTextTwoLines(activeDevice,this.controlIndex,0,paramName)
                updateDisplay(activeDevice,8,cText,1,pluginName,0,0,0,0)

            }

        }.bind({controlIndex})

        fqcControl.mOnDisplayValueChange=function(activeDevice,activeMapping,displayValue){

            //same thing as above
            if(isSubPageSelected(activeDevice,"fqc")==true){

                updateDisplay(activeDevice,this.controlIndex,cText,2,displayValue,0,0,0,0)

            } 

        }.bind({controlIndex})

        
        

        //Focuced Quick Controls 2 (Knob AI and Lock)
        var fqc2Control=fqc2Params[controlIndex]
        page.makeValueBinding(knob,fqc2Control).setSubPage(subPages["fqc2"])
        page.makeValueBinding(button,fqc2Params[8+controlIndex]).setTypeToggle().setSubPage(subPages["fqc2"]).mOnValueChange=function(activeDevice,activeMapping,value,diff){

            if(this.controlIndex==0){

                var ledObject=cV.leds.underDisplay[0]
                ledObject.intensity=value 
                updateLed(activeDevice,ledObject)
                var buttonColor=cV.colorsPerButtonPerSubPage["fqc2"][0]
                updateDisplay(activeDevice,0,cColor,2,"",buttonColor[0]*value,buttonColor[1]*value,buttonColor[2]*value,0)
                updateDisplay(activeDevice,0,cValue,1,"",0,0,0,value)

            }

        }.bind({controlIndex})

        

        
        //Instrument Quick Controls 
        var instrumentControl=instrumentBankZone.makeParameterValue()
        page.makeValueBinding(knob,instrumentControl).setSubPage(subPages["qc"])
        
        var qcButtonBinding=qcButtons[controlIndex]
        bindButton(button,qcButtonBinding,subPages["qc"])

        //Pregain
        page.makeValueBinding(knob,preGainParams[controlIndex]).setSubPage(subPages["pregain"])

        page.makeValueBinding(button,preGainParams[8+controlIndex]).setSubPage(subPages["pregain"]).setTypeToggle()

        //EQ
        page.makeValueBinding(knob,eqParams[controlIndex]).setSubPage(subPages["eq"])
        page.makeValueBinding(button,eqParamsButtons[controlIndex]).setSubPage(subPages["eq"]).setTypeToggle()

        //EQ 2
        page.makeValueBinding(knob,eq2Params[controlIndex]).setSubPage(subPages["eq2"])
        page.makeValueBinding(button,eqParamsButtons[controlIndex]).setSubPage(subPages["eq2"]).setTypeToggle()
        
        //inserts 
        var insertParam=insertsParamsZone.makeParameterValue()
        page.makeValueBinding(knob,insertParam).setSubPage(subPages["inserts"])

        bindButton(button,insertsParamsButtons[controlIndex],subPages["inserts"])

        
        //channel strip 
        for(var otherStripEffectsIndex=0;otherStripEffectsIndex<otherStripEffects.length;otherStripEffectsIndex++){

            var stripSubPage=subPages[cV.stripSubPages[otherStripEffectsIndex]]
            var stripEffect=otherStripEffects[otherStripEffectsIndex]
            var stripParamKnob=stripEffect.mParameterBankZone.makeParameterValue()

            page.makeValueBinding(knob,stripParamKnob).setSubPage(stripSubPage)

            var stripEffectButtonParam=stripEffectsButtons[otherStripEffectsIndex][controlIndex]
            page.makeValueBinding(button,stripEffectButtonParam).setSubPage(stripSubPage).setTypeToggle()

        }
        
        //sends 
        var sendSlot=page.mHostAccess.mTrackSelection.mMixerChannel.mSends.getByIndex(controlIndex)

        page.makeValueBinding(knob,sendSlot.mLevel).setSubPage(subPages["sends"])
        page.makeValueBinding(button,sendSlot.mOn).setSubPage(subPages["sends"]).setTypeToggle()

        page.makeValueBinding(knob,sendSlot.mLevel).setSubPage(subPages["sends2"])
        page.makeValueBinding(button,sendSlot.mPrePost).setSubPage(subPages["sends2"]).setTypeToggle()

       

        //dummy knobs
        var knobsToDummyArr=["shift","shift2","ctrl","alt","fn","commands1","commands2","commands3","commands4","commands5"]
        var knobsToDummyArrS=["Shift","Shift2","Ctrl","Alt","FN","commands1","commands2","commands3","commands4","commands5"]

        //used for browsing in MCU
        if(generalSettings.strippedDownVersion==0){
            
            knobsToDummyArr.push("grid")
        
        }
        
        if(controlIndex!=6){

            //hard-coded click-level, I really have to change this later
            knobsToDummyArr.forEach(function(tempState){

            
                page.makeValueBinding(knob,dummyVarToConsumeControls).setSubPage(subPages[tempState]).mOnValueChange=function(activeDevice,activeMapping,value,diff){
            
                    turnLeftRight(activeDevice,this.controlIndex,value,diff)
            
                }.bind({controlIndex})
            
            })

        }
        

        
        
        var knobLeft=ourSurface.knobsLeft[controlIndex]
        var knobRight=ourSurface.knobsRight[controlIndex]

        consumingKnobLeftRightSubPages.forEach(function(consumingSubPageName){
        
            page.makeValueBinding(knobLeft,dummyVarToConsumeControls).setSubPage(subPages[consumingSubPageName])
        
            page.makeValueBinding(knobRight,dummyVarToConsumeControls).setSubPage(subPages[consumingSubPageName])
            
        })
        
    }

    function bindButton(control,binding,subPage){
        
        if(typeof binding == "string"){

            var commandBindingArr=binding.split(",")

            var commandCategory=commandBindingArr[0]
            var commandName=commandBindingArr[1]
    
            if(commandBindingArr.length==3){
    
                page.makeCommandBinding(control,commandCategory,commandName).setSubPage(subPage).makeRepeating(0.2,10)
            
            } else {

                page.makeCommandBinding(control,commandCategory,commandName).setSubPage(subPage)

            }

            
        } else {

            page.makeValueBinding(control,binding).setSubPage(subPage).setTypeToggle()
        
        }

    }

    
    page.makeCommandBinding(ourSurface.custom.soloDefeat,"Edit","Solo Defeat").setSubPage(subPagesButtonsAboveFaders.monitorDefeat)
        

    if(generalSettings.display.dawInfo==1){
        
        page.mHostAccess.mTransport.mTimeDisplay.mPrimary.mTransportLocator.mOnChange=function(activeDevice,activeMapping,currentCursorPosition,arg3){
    
            currentCursorPosition=currentCursorPosition.replace(" ","").replace(" ","").replace(" ","")
            cV.cursor=currentCursorPosition
            
            updateDawInfo(activeDevice,2,1,cV.cursor)

            if(arg3=="Bars+Beats" && generalSettings.flashPadsInSync==1 && activeDevice.getState("isPlaying")=="1"){

                var indexOfBeat=currentCursorPosition.indexOf(".")+1
                var beat=parseInt(currentCursorPosition.substring(indexOfBeat,indexOfBeat+2))
                var prevBeat=parseInt(activeDevice.getState("beat"))
                
                if(beat!=prevBeat && beat<5){
                
                    Helper_updateBeats(activeDevice,beat)
                
                }
                
            }
        
        }

        page.mHostAccess.mTransport.mTimeDisplay.mPrimary.mCycleLocatorLeft.mOnChange=function(activeDevice,activeMapping,cycleLocatorLeft){
            
            cycleLocatorLeft=cycleLocatorLeft.substring(0,cycleLocatorLeft.lastIndexOf(".")).replace(" ","").replace(" ","").replace(" ","")
            cV.leftLocator="L:"+cycleLocatorLeft
            
            updateDawInfo(activeDevice,0,1,cV.leftLocator)
            
        }

        page.mHostAccess.mTransport.mTimeDisplay.mPrimary.mCycleLocatorRight.mOnChange=function(activeDevice,activeMapping,cycleLocatorRight){
          
            cycleLocatorRight=cycleLocatorRight.substring(0,cycleLocatorRight.lastIndexOf(".")).replace(" ","").replace(" ","").replace(" ","")
            cV.rightLocator="R:"+cycleLocatorRight
            updateDawInfo(activeDevice,1,1,cV.rightLocator)
            
        }

       
        
    
        page.mHostAccess.mTransport.mTimeDisplay.mOnChangeTempoBPM=function(activeDevice,activeMapping,BPM){
        
            var tempoRounded=BPM.toFixed(2)
            cV.BPM=parseInt(tempoRounded)
            cV.BPMWhole="B:"+tempoRounded
        
            updateDawInfo(activeDevice,7,1,cV.BPMWhole)
        
        }

        
        

    }
    
    var subPagesCustomNames=["shift","shift2","ctrl","alt","fn"]
    var subPagesCustomNamesInMap=["Shift","Shift2","Ctrl","Alt","FN"]
    var subPagesCustomToCommandsMap=["commands1","commands2","commands3","commands4","commands5"]
    
    var dummyBPMUpHostValue=page.mCustom.makeHostValueVariable("dummyBPMUp")
    var dummyBPMDownHostValue=page.mCustom.makeHostValueVariable("dummyBPMDown")

   for(var i=0;i<subPagesCustomNames.length;i++){

        var customBindVarNameLeft8="knobLeft8With"+subPagesCustomNamesInMap[i]
        var customBindVarNameRight8="knobRight8With"+subPagesCustomNamesInMap[i]
        
        if(bindings[customBindVarNameLeft8][0]=="Custom" && bindings[customBindVarNameRight8][0]=="Custom"){
           
            var twoBindings=[subPagesCustomNames[i],subPagesCustomToCommandsMap[i]]
            twoBindings.forEach(function(tmpSubPageName){

                page.makeValueBinding(ourSurface.knobsRight[7],dummyBPMUpHostValue).setSubPage(subPages[tmpSubPageName]).mOnValueChange=function(activeDevice,activeMapping,value,diff){
    
                    var previousBPM=cV.BPM
                    
                    if(previousBPM<360){
                    
                        previousBPM++
                        
                        page.mHostAccess.mTransport.mTimeDisplay.setTempoBPM(activeMapping,previousBPM)
    
                    }
                
                }
                
                page.makeValueBinding(ourSurface.knobsLeft[7],dummyBPMDownHostValue).setSubPage(subPages[tmpSubPageName]).mOnValueChange=function(activeDevice,activeMapping,value,diff){
        
                    var previousBPM=cV.BPM
                
                    if(previousBPM>1){
                
                        previousBPM--
                        
                        page.mHostAccess.mTransport.mTimeDisplay.setTempoBPM(activeMapping,previousBPM)
                
                    }
                
                }

            })
                
        }

        var customBindVarNameLeft7="knobLeft7With"+subPagesCustomNamesInMap[i]
        var customBindVarNameRight7="knobRight7With"+subPagesCustomNamesInMap[i]
       
        if(bindings[customBindVarNameLeft7][0]=="Custom" && bindings[customBindVarNameRight7][0]=="Custom"){
           
            page.makeValueBinding(ourSurface.knobs[6].mSurfaceValue,page.mHostAccess.mTransport.mValue.mMetronomeClickLevel).setSubPage(subPages[subPagesCustomNames[i]])

            page.makeValueBinding(ourSurface.knobs[6].mSurfaceValue,page.mHostAccess.mTransport.mValue.mMetronomeClickLevel).setSubPage(subPages[subPagesCustomToCommandsMap[i]])
    
        }

    }
    
    
    page.makeActionBinding(ourSurface.buttons.trackLeft.mSurfaceValue,mixerBankZone.mAction.mPrevBank).setSubPage(subPages["shift"])
    page.makeActionBinding(ourSurface.buttons.trackRight.mSurfaceValue,mixerBankZone.mAction.mNextBank).setSubPage(subPages["shift"])

    //options
    var dummyOptionSelectedTracksAppearanceOptionScreens=page.mCustom.makeHostValueVariable("selectedTracksAppearanceOptionScreens")
    page.makeValueBinding(ourSurface.buttons.arrowRightA.mSurfaceValue,dummyOptionSelectedTracksAppearanceOptionScreens).setSubPage(subPages["options"]).mOnValueChange=function(activeDevice,activeMapping,value,diff){

        if(value==1){

            generalSettings.display.selectedTracksAppearanceOptionScreens=1- generalSettings.display.selectedTracksAppearanceOptionScreens

            var notification="Selected Track [D]"
            var notification2="Pulsing OFF"
           
            if(generalSettings.display.selectedTracksAppearanceOptionScreens==1){
                
                notification2="ON"
            
            }
            
            notify(activeDevice,[notification,notification2])
        
        }
    
    }

    var dummyOptionSelectedTracksAppearanceOptionFaders=page.mCustom.makeHostValueVariable("selectedTracksAppearanceOptionFaders")
    page.makeValueBinding(ourSurface.buttons.arrowRightB.mSurfaceValue,dummyOptionSelectedTracksAppearanceOptionFaders).setSubPage(subPages["options"]).mOnValueChange=function(activeDevice,activeMapping,value,diff){

        if(value==1){

            generalSettings.display.selectedTracksAppearanceOptionFaders=1-generalSettings.display.selectedTracksAppearanceOptionFaders

            var notification="Selected Track [F]"
            var notification2="Pulsing OFF"
           
            if(generalSettings.display.selectedTracksAppearanceOptionFaders==1){
                
                notification2="ON"
            
            }
            
            notify(activeDevice,[notification,notification2])
        
        }
    
    }

    var dummyOptionPulsePad8=page.mCustom.makeHostValueVariable("pulsePad8")
    page.makeValueBinding(ourSurface.pads[7].mSurfaceValue,dummyOptionPulsePad8).setSubPage(subPages["options"]).mOnValueChange=function(activeDevice,activeMapping,value,diff){

        if((value>0) && (value==diff || diff==0)){

            generalSettings.pulsePad8=1-generalSettings.pulsePad8

            var notification="Pad 8"
            var notification2="Pulsing OFF"
            if(generalSettings.pulsePad8==1){
                
                notification2="Pulsing ON"
            
            }
            
            notify(activeDevice,[notification,notification2])

            var ledObject=cV.leds.pads[7]
            ledObject.solidFlashPulse=1+generalSettings.pulsePad8
            ledObject.r=generalSettings.pulsePad8Color[0]*generalSettings.pulsePad8
            ledObject.g=generalSettings.pulsePad8Color[1]*generalSettings.pulsePad8
            ledObject.b=generalSettings.pulsePad8Color[2]*generalSettings.pulsePad8
            updateLed(activeDevice,ledObject)
        
        }
    
    }

    var dummyOptionFlashPadsInSync=page.mCustom.makeHostValueVariable("flashPadsInSync")
    page.makeValueBinding(ourSurface.pads[15].mSurfaceValue,dummyOptionFlashPadsInSync).setSubPage(subPages["options"]).mOnValueChange=function(activeDevice,activeMapping,value,diff){
        
        if((value>0) && (value==diff || diff==0)){

            generalSettings.flashPadsInSync=1-generalSettings.flashPadsInSync

            var notification="Pads Synced"
            var notification2="OFF"
            if(generalSettings.flashPadsInSync==1){
                
                notification2="ON"
            
            }
            
            notify(activeDevice,[notification,notification2])

        }
            
    }

    var dummyOptionNightMode=page.mCustom.makeHostValueVariable("nightMode")
    page.makeValueBinding(ourSurface.pads[9].mSurfaceValue,dummyOptionNightMode).setSubPage(subPages["options"]).mOnValueChange=function(activeDevice,activeMapping,value,diff){

        if((value>0) && (value==diff || diff==0)){

            generalSettings.nightMode=1-generalSettings.nightMode

        }
    
    }


    page.makeValueBinding(ourSurface.buttons.record.mSurfaceValue,page.mHostAccess.mTransport.mValue.mMetronomeActive).setTypeToggle().setSubPage(subPages["options"])

    page.makeCommandBinding(ourSurface.buttons.rewind.mSurfaceValue,'Transport', 'Auto Punch In').setSubPage(subPages["options"])

    page.makeCommandBinding(ourSurface.buttons.forward.mSurfaceValue,'Transport', 'Auto Punch Out').setSubPage(subPages["options"])

    page.makeCommandBinding(ourSurface.buttons.rewind.mSurfaceValue,'Zoom', 'Zoom Out').setSubPage(subPages["grid"]).makeRepeating(generalSettings.commandRepeatInitialDelay,generalSettings.commandRepeatFrequency)

    page.makeCommandBinding(ourSurface.buttons.forward.mSurfaceValue,'Zoom', 'Zoom In').setSubPage(subPages["grid"]).makeRepeating(generalSettings.commandRepeatInitialDelay,generalSettings.commandRepeatFrequency)

    

    //Lock pads/arrows/knobs in grid and options subPages

    for(var countDummy=0;countDummy<8;countDummy++){

        page.makeValueBinding(ourSurface.knobs[countDummy].mSurfaceValue,dummyVarToConsumeControls).setSubPage(subPages["grid"])
        page.makeValueBinding(ourSurface.knobs[countDummy].mSurfaceValue,dummyVarToConsumeControls).setSubPage(subPages["options"])

        if(generalSettings.strippedDownVersion==1){

           
            page.makeValueBinding(ourSurface.knobsLeft[countDummy],dummyVarToConsumeControls).setSubPage(subPages["grid"])

            page.makeValueBinding(ourSurface.knobsRight[countDummy],dummyVarToConsumeControls).setSubPage(subPages["grid"])

        }
        
        page.makeValueBinding(ourSurface.knobsLeft[countDummy],dummyVarToConsumeControls).setSubPage(subPages["options"])

        
        page.makeValueBinding(ourSurface.knobsRight[countDummy],dummyVarToConsumeControls).setSubPage(subPages["options"])

        page.makeValueBinding(ourSurface.pads[countDummy].mSurfaceValue,dummyVarToConsumeControls).setSubPage(subPages["grid"])
        
        if(countDummy!=7){
            //pad 8 is assigned to flashing pad 8
            page.makeValueBinding(ourSurface.pads[countDummy].mSurfaceValue,dummyVarToConsumeControls).setSubPage(subPages["options"])

        }
        
        page.makeValueBinding(ourSurface.pads[8+countDummy].mSurfaceValue,dummyVarToConsumeControls).setSubPage(subPages["grid"])
        
        if(countDummy!=0 && countDummy!=7){
            //pads 8 & 16 are assigned to night mode & sync flash
            page.makeValueBinding(ourSurface.pads[8+countDummy].mSurfaceValue,dummyVarToConsumeControls).setSubPage(subPages["options"])

        }
        

    }

    var otherControlsToDeactivateInGridAndOptions=[ourSurface.buttons.arrowDnPads,ourSurface.buttons.arrowDnScreen,ourSurface.buttons.arrowUpPads,ourSurface.buttons.arrowUpScreen,ourSurface.buttons.trackLeft,ourSurface.buttons.trackRight]
    
    otherControlsToDeactivateInGridAndOptions.forEach(function(deactivateControl){

        page.makeValueBinding(deactivateControl.mSurfaceValue,dummyVarToConsumeControls).setSubPage(subPages["grid"])
        page.makeValueBinding(deactivateControl.mSurfaceValue,dummyVarToConsumeControls).setSubPage(subPages["options"])

    })

    //MCU HANDLES

    if(generalSettings.strippedDownVersion==0){

        var dummyMCUHandlerLeft=page.mCustom.makeHostValueVariable("mcuHandlerLeft")

        var dummyMCUHandlerRight=page.mCustom.makeHostValueVariable("mcuHandlerRight")

        for(var dummyKnobIndex=0;dummyKnobIndex<8;dummyKnobIndex++){

            page.makeValueBinding(ourSurface.knobsLeft[dummyKnobIndex],dummyMCUHandlerLeft).setSubPage(subPages["grid"]).mOnValueChange=function(activeDevice,activeMapping,value,diff){
               
                Helper_MCUChangeValue(activeDevice,this.dummyKnobIndex,-1)
    
            }.bind({dummyKnobIndex})
    
            page.makeValueBinding(ourSurface.knobsRight[dummyKnobIndex],dummyMCUHandlerRight).setSubPage(subPages["grid"]).mOnValueChange=function(activeDevice,activeMapping,value,diff){
    
                Helper_MCUChangeValue(activeDevice,this.dummyKnobIndex,1)
    
            }.bind({dummyKnobIndex})
    
        }
        
    }

    page.makeActionBinding(ourSurface.buttons.arrowUpPads.mSurfaceValue,deviceDriver.mAction.mNextPage).setSubPage(subPages["shift"])

    page.makeActionBinding(ourSurface.buttons.arrowDnPads.mSurfaceValue,deviceDriver.mAction.mPrevPage).setSubPage(subPages["shift"])

    
    var labelKeys=Object.keys(ourSurface.labels)
    labelKeys.forEach(function(labelKey){
     
        var label=ourSurface.labels[labelKey]
        var labelField=label.labelField
        var labelText=label.text 
        page.setLabelFieldText(labelField,labelText)
    
    })

    var onActivate = function (activeDevice) {
       
        activeDevice.setState("selectedPage",cV.constPageNameMixer)
       
        updateAllSectionsPads(activeDevice)
        
    }

    function localMakeCommand(/**@type {MR_SurfaceValue}*/control,/**@type {String}*/commandCategory,/**@type {String}*/commandName,subPageName,/**@type {Number}*/repeat){
        
       if(repeat==0){

            if(subPageName==""){

                page.makeCommandBinding(control,commandCategory,commandName)        
            
            } else {

                page.makeCommandBinding(control,commandCategory,commandName).setSubPage(subPages[subPageName])
            
            }

        } else {

            if(subPageName==""){

                page.makeCommandBinding(control,commandCategory,commandName).makeRepeating(generalSettings.commandRepeatInitialDelay,generalSettings.commandRepeatFrequency)
            
            } else {

                page.makeCommandBinding(control,commandCategory,commandName).setSubPage(subPages[subPageName]).makeRepeating(generalSettings.commandRepeatInitialDelay,generalSettings.commandRepeatFrequency)
            
            }

        }
        
    }

    return {page,onActivate,subPages} 

}

/**
* @param {String} text 
*/
function getBytesFromText(text){
    
    if(text==undefined){

        text=" "
    
    }
    
    if(text.length==0){
    
        text=" "
    
    }
    
    var bytes=[]
    var i=0
    var maxLen=Math.min(text.length,cV.displayColumnLength)
    
    while (i<maxLen){
    
        var char=text.charCodeAt(i)
    
        if (char>127){

            char=32
        
        }
        
        bytes.push(char)
    
        i++
    
    }
    
    bytes.push(0x00)
    
    return bytes 

}


function updateDisplay(activeDevice,columnIndex,propertyType,objectIndex,text,r,g,b,value){
    
    var finalSysex=[]
    var data=[]
    
    switch (propertyType){

        case cText:
            
            //text 
            var i=0
            if(text.length==0 || text==undefined){

                text=" "
            
            }
            var maxLen=Math.min(text.length,cV.displayColumnLength)
    
            while (i<maxLen){
            
                var char=text.charCodeAt(i)
            
                if (char>127){

                    char=32
                
                }
              
                data.push(char)
                i++
            
            }
            
            data.push(0x00)
            
            break 

        case cColor:
            
            //rgb color
            data.push(r,g,b)
            
            break 
        
        case cValue:
            
            //parameter value 0-127
            data.push(value)
            
            break 

    }

    finalSysex=cV.sysexHeader.concat([0x02,columnIndex,propertyType,objectIndex],data,[0xF7])
    
    if(cV.initialized==true){
        
        midiOutput.sendMidi(activeDevice,finalSysex)
    
    } else {

        cV.lstOfSysexUponActivating.push(finalSysex)
    
    }
    
}

function updateLed(activeDevice,ledObject){
    
    var ledID=ledObject.ledID
    var r=ledObject.r
    var g=ledObject.g
    var b=ledObject.b
   
    if(ledObject.intensity!=undefined){
        
        var intensity=ledObject.intensity
        r=r*intensity
        g=g*intensity
        b=b*intensity
        
    }

    var solidFlashPulse=ledObject.solidFlashPulse
    
    var finalSysex=[]
    
    finalSysex=cV.sysexHeader.concat([0x03,ledID,solidFlashPulse,r,g,b,0xF7])
    
    if(cV.initialized==true){
        
        midiOutput.sendMidi(activeDevice,finalSysex)

    } else {

        cV.lstOfSysexUponActivating.push(finalSysex)
    
    }
    
}


function clearLeds(activeDevice,refreshSubPagesColorsInNightMode,comingFromAStateSubPage){ 

    var dataColor=[
    
        0x03,

        cV.leds.underDisplay[0].ledID,1,0,0,0,
        cV.leds.underDisplay[1].ledID,1,0,0,0,
        cV.leds.underDisplay[2].ledID,1,0,0,0,
        cV.leds.underDisplay[3].ledID,1,0,0,0,
        cV.leds.underDisplay[4].ledID,1,0,0,0,
        cV.leds.underDisplay[5].ledID,1,0,0,0,
        cV.leds.underDisplay[6].ledID,1,0,0,0,
        cV.leds.underDisplay[7].ledID,1,0,0,0,
    
    ]

    var nm=generalSettings.nightMode
    var padColorsR=[0,0,0,0,0,0,0,0,0]
    var padColorsG=[0,0,0,0,0,0,0,0,0]
    var padColorsB=[0,0,0,0,0,0,0,0,0]
    
    if(comingFromAStateSubPage==true && refreshSubPagesColorsInNightMode){
        
        var intensePads=generalSettings.nightModePadsIntensity

        for(var pad=0;pad<8;pad++){

                var padColor=cV.colorsPerMainSection[pad]
                padColorsR[pad]=padColor[0]*intensePads
                padColorsG[pad]=padColor[1]*intensePads
                padColorsB[pad]=padColor[2]*intensePads
            
        }
        
        
        var intenseB=generalSettings.nightModeOtherButtonsIntensity
        var nm2=intenseB*generalSettings.nightMode

        var padsAndTransport=[
        
            cV.leds.pads[0].ledID,1,padColorsR[0],padColorsG[0],padColorsB[0],
            cV.leds.pads[1].ledID,1,padColorsR[1],padColorsG[1],padColorsB[1],
            cV.leds.pads[2].ledID,1,padColorsR[2],padColorsG[2],padColorsB[2],
            cV.leds.pads[3].ledID,1,padColorsR[3],padColorsG[3],padColorsB[3],
            cV.leds.pads[4].ledID,1,padColorsR[4],padColorsG[4],padColorsB[4],
            cV.leds.pads[5].ledID,1,padColorsR[5],padColorsG[5],padColorsB[5],
            cV.leds.pads[6].ledID,1,padColorsR[6],padColorsG[6],padColorsB[6],
            cV.leds.pads[7].ledID,1,0,0,0,
            cV.leds.pads[8].ledID,1,0,0,0,
            cV.leds.pads[9].ledID,1,0,0,0,
            cV.leds.pads[10].ledID,1,0,0,0,
            cV.leds.pads[11].ledID,1,0,0,0,
            cV.leds.pads[12].ledID,1,padColorsR[7],padColorsG[7],padColorsB[7],
            cV.leds.pads[13].ledID,1,0,0,0,
            cV.leds.pads[14].ledID,1,0,0,0,
            cV.leds.pads[15].ledID,1,0,0,0,

            cV.leds.rewind.ledID,1,cV.leds.rewind.r,cV.leds.rewind.g,cV.leds.rewind.b,
            cV.leds.forward.ledID,1,cV.leds.forward.r,cV.leds.forward.g,cV.leds.forward.b,
            cV.leds.stop.ledID,1,cV.leds.stop.r,cV.leds.stop.g,cV.leds.stop.b,
            cV.leds.play.ledID,1,cV.leds.play.r,cV.leds.play.g,cV.leds.play.b,
            cV.leds.loop.ledID,1,cV.leds.loop.r,cV.leds.loop.g,cV.leds.loop.b,
            cV.leds.record.ledID,1,cV.leds.record.r,cV.leds.record.g,cV.leds.record.b,

            cV.leds.duplicate.ledID,1,cV.leds.duplicate.night[0]*nm2,cV.leds.duplicate.night[1]*nm2,cV.leds.duplicate.night[2]*nm2,

            cV.leds.clear.ledID,1,cV.leds.clear.night[0]*nm2,cV.leds.clear.night[1]*nm2,cV.leds.clear.night[2]*nm2,

            cV.leds.arrowRightA.ledID,1,cV.leds.arrowRightA.night[0]*nm2,cV.leds.arrowRightA.night[1]*nm2,cV.leds.arrowRightA.night[2]*nm2,

            cV.leds.arrowRightB.ledID,1,cV.leds.arrowRightB.night[0]*nm2,cV.leds.arrowRightB.night[1]*nm2,cV.leds.arrowRightB.night[2]*nm2,

            cV.leds.arrowUpPads.ledID,1,cV.leds.arrowUpPads.night[0]*nm2,cV.leds.arrowUpPads.night[1]*nm2,cV.leds.arrowUpPads.night[2]*nm2,

            cV.leds.arrowDnPads.ledID,1,cV.leds.arrowDnPads.night[0]*nm2,cV.leds.arrowDnPads.night[1]*nm2,cV.leds.arrowDnPads.night[2]*nm2,

            cV.leds.trackLeft.ledID,1,cV.leds.trackLeft.night[0]*nm2,cV.leds.trackLeft.night[1]*nm2,cV.leds.trackLeft.night[1]*nm2,

            cV.leds.trackRight.ledID,1,cV.leds.trackRight.night[0]*nm2,cV.leds.trackRight.night[1]*nm2,cV.leds.trackRight.night[1]*nm2


        ]

        dataColor.push.apply(dataColor,padsAndTransport)
    
    }
        
    sendLongSysex(activeDevice,dataColor)

}

function clearAllLeds(activeDevice){

    sendLongSysex(activeDevice,cV.clearAllLeds)

}

function clearTextBottomLines(activeDevice,bothLines){

    var displayType=parseInt(activeDevice.getState("displayType"))
    var bottomRow=1+2*displayType
    var dataText=[

        0x02,
        0,cText,bottomRow,32,0,
        1,cText,bottomRow,32,0,
        2,cText,bottomRow,32,0,
        3,cText,bottomRow,32,0,
        4,cText,bottomRow,32,0,
        5,cText,bottomRow,32,0,
        6,cText,bottomRow,32,0,
        7,cText,bottomRow,32,0
        
    ]

    if(bothLines==true){
        
        var preBottomRow=bottomRow-1
        dataText.push(
            0,cText,preBottomRow,32,0,
            1,cText,preBottomRow,32,0,
            2,cText,preBottomRow,32,0,
            3,cText,preBottomRow,32,0,
            4,cText,preBottomRow,32,0,
            5,cText,preBottomRow,32,0,
            6,cText,preBottomRow,32,0,
            7,cText,preBottomRow,32,0)
    
    }

    sendLongSysex(activeDevice,dataText)

}

function Helper_tapTempo(activeDevice,activeMapping,page){
    
    var currentTime = new Date().getTime();
    var startTime=activeDevice.getState("currentTimeForTempo")
    var lastTappedTime=activeDevice.getState("lastTappedTimeForTempo")
    var taps=activeDevice.getState("currentTapsForTempo")
            
    if(taps!=""){
                
        var previousTappedTime=1*lastTappedTime
        var diffFromPrevTapped=currentTime-previousTappedTime
        if(diffFromPrevTapped>3000){
            
            //we reset tapping
            activeDevice.setState("currentTimeForTempo",""+currentTime)
            activeDevice.setState("currentTapsForTempo","0")

        } else {
            
            var diffTime= currentTime-startTime
            var tapsInt=1*taps
            tapsInt++
            var tmpTempo=60000*tapsInt/diffTime
            
            var tempoRounded=Math.round(tmpTempo)
            
            cV.BPM=tempoRounded
            
            activeDevice.setState("currentTapsForTempo",""+tapsInt)
            
            page.mHostAccess.mTransport.mTimeDisplay.setTempoBPM(activeMapping,tempoRounded)

            notify(activeDevice,["Tapping Tempo",""+cV.BPM])
            
        }
        
    } else {
        
        //we reset tapping
        activeDevice.setState("currentTimeForTempo",""+currentTime)
        activeDevice.setState("currentTapsForTempo","0")
    
    }

    activeDevice.setState("lastTappedTimeForTempo",""+currentTime)
            
}


/**
 * 
 * @param {MR_ActiveDevice} activeDevice 
 * @param {Array} rows 
 */
function notify(activeDevice,rows){

    var finalSysex=[]
    var data=[]
    
    for(var rowIndex=0;rowIndex<rows.length;rowIndex++){
        
        var text=rows[rowIndex]
        var i=0
        var maxLen=Math.min(text.length,18)
        
        while (i<maxLen){
    
            var char=text.charCodeAt(i)
    
            if (char>127){

                char=32
        
            }
        
            data.push(char)
        
            i++
    
        }
    
        data.push(0x00)

    }
    
    finalSysex=cV.sysexHeader.concat([0x04],data,[0xF7])

    if(cV.initialized==true){
        
        midiOutput.sendMidi(activeDevice,finalSysex)
    
    } else {

        cV.lstOfSysexUponActivating.push(finalSysex)
    
    }
    
}


function makeSubPages(page,subPagesAreaName,updateDisplayType,subPagesProperties){

    var subPagesNames=Object.keys(subPagesProperties)
    
    var subPagesArea=page.makeSubPageArea(subPagesAreaName)
    var subPages={}
    var subPagesSections={}
    var subPagesForNavigating=[]
    var subPageIndex=0
    var subPageMappedIndex=-1

    subPagesNames.forEach(function(subPageName){
        
        subPages[subPageName]=subPagesArea.makeSubPage(subPageName)
        
        var subPageProperties=subPagesProperties[subPageName]

        if(subPageProperties.section!=undefined){

            var section=subPageProperties.section

            if(!(section in subPagesSections)){

                subPagesSections[section]=[]
                subPagesForNavigating.push(section)
                cV.colorsPerMainSection.push(subPageProperties.color)
                subPageMappedIndex++

            }    
            
            var sectionSubPages=subPagesSections[section]
            sectionSubPages.push(subPageName)
            
        }

        var displayName=subPageProperties.dispName
        var color=subPageProperties.color
        
        var boundLed=subPageProperties.led 
        var buttonHeaders=subPageProperties.buttonHeaders
        
        subPages[subPageName].mOnActivate=function(activeDevice,activeMapping){
            
            var currentSubPageName=this.subPageName
            
            var previousSubPageName=activeDevice.getState(this.subPagesAreaName)
            if(previousSubPageName==""){previousSubPageName="mixer"}
            
            var isPreviousOptionsOrGrid=["options","grid"].indexOf(previousSubPageName)+1

            if(currentSubPageName== activeDevice.getState("subPageShiftPreActivation")){

                activeDevice.setState("subPageShiftPreActivation","")
            
            }

            activeDevice.setState(this.subPagesAreaName,currentSubPageName)
            activeDevice.setState(this.subPagesAreaName+"index",""+this.subPageIndex)
            activeDevice.setState("state"+currentSubPageName,"1")

            if(this.section!=undefined){

                activeDevice.setState("mappedSubPageIndex",""+this.subPageMappedIndex)
            
            }

            var dataText=[0x02]

            if (this.updateDisplayType==1){

                var rows=this.displayName.split("-")
                    
                var color1=cV.colorsPerSubPageButton1Faders[currentSubPageName][0]
                var color2=cV.colorsPerSubPageButton1Faders[currentSubPageName][1]
                
                var dataTextFinal=dataText.concat([8,cText,2],getBytesFromText(rows[0]),[8,cText,3],getBytesFromText(rows[1]),[8,cColor,1],color1,[8,cColor,2],color2)
                
                if (dataTextFinal.length>1){
                        
                    sendLongSysex(activeDevice,dataTextFinal)

                }

                return 

            }

            if(cV.subPagesForDawInfoDisplay.indexOf(currentSubPageName)>-1){
               //all states and commands subpages
                activeDevice.setState("displayType","2")
               
               
                if(isPreviousOptionsOrGrid==1){
                
                    clearTextBottomLines(activeDevice,false)

               } else {

                    sendSysex(activeDevice,1,2,[])

                    clearLeds(activeDevice,currentSubPageName.indexOf("commands")==0,currentSubPageName.indexOf("commands")==0)

               }
                

                updateDawInfo(activeDevice,7,1,cV.BPMWhole)

                updateDawInfo(activeDevice,6,1,""+cV.clickLevel)

                updateDawInfo(activeDevice,5,1,cV.metroActive==0 ? "Metro OFF" : "Metro ON")
               
                updateDawInfo(activeDevice,1,1,cV.rightLocator)
               
                updateDawInfo(activeDevice,0,1,cV.leftLocator)
               
                updateDawInfo(activeDevice,2,1,cV.cursor)

                if(generalSettings.strippedDownVersion==0){

                    var midiCycleRecordMode=activeDevice.getState("midiCycleRecordMode")

                    var midiRecordMode=activeDevice.getState("midiRecordMode")

                    updateDawInfo(activeDevice,3,1,midiRecordMode)
                    updateDawInfo(activeDevice,4,1,midiCycleRecordMode)
                
                }

            } else if (!(currentSubPageName=="grid" || currentSubPageName=="options" || this.subPagesAreaName=="buttonsAboveFaders")){
                
                if(!(previousSubPageName=="grid" || previousSubPageName=="options") && cV.subPagesForDawInfoDisplay.indexOf(previousSubPageName)!=-1){
                    
                    sendSysex(activeDevice,1,1,[])

                }
                
                activeDevice.setState("displayType","1")
                
                if(isPreviousOptionsOrGrid==1){

                    clearTextBottomLines(activeDevice,false)

                } else {

                    var realClear=false 
                  
                    if(["shift","shift2","ctrl","alt","fn"].indexOf(previousSubPageName)>-1){
    
                        realClear=true 
    
                    }
    
                    clearLeds(activeDevice,true,realClear)

                    clearTextBottomLines(activeDevice,true)
                  
                    for(var focusedIndex=0;focusedIndex<8;focusedIndex++){

                        updateDisplay(activeDevice,focusedIndex,cValue,1,"",0,0,0,0)
                        updateDisplay(activeDevice,focusedIndex,cColor,2,"",0,0,0,0)

                        if(subPageName=="fqc2"){

                            sendTextTwoLines(activeDevice,focusedIndex,0,"")
                            
                        }
                    
                    }
                
                }
                
            }
            
            var dataColor=[0x03]
            
            if(["shift","shift2","ctrl","alt","fn","grid","options"].indexOf(currentSubPageName)==-1){
                
                activeDevice.setState(this.subPagesAreaName+"prev",currentSubPageName)

            }

            if(this.boundLed!=undefined && typeof this.boundLed!="number"){
            
                var ledObject=this.boundLed
                ledObject.r=this.color[0]
                ledObject.g=this.color[1]
                ledObject.b=this.color[2]
            
                dataColor.push(ledObject.ledID,1,this.color[0],this.color[1],this.color[2])
            
            }

            var row2OfMainDisplay=this.displayName 
            var indexOfStripPage=cV.stripSubPages.indexOf(currentSubPageName)
            if(indexOfStripPage>-1){

                row2OfMainDisplay=activeDevice.getState("strip"+indexOfStripPage)

                if(row2OfMainDisplay==""){

                    row2OfMainDisplay=this.displayName
                
                }
            
            } else if (currentSubPageName=="inserts"){

                var indexOfInsert=activeDevice.getState("insertindex")
                
                if(indexOfInsert!=""){

                    var insertNameVar="insertname"+indexOfInsert
                    var insertName=activeDevice.getState(insertNameVar)
                   
                    if(insertName.length>0){

                        row2OfMainDisplay=insertName

                    }
                
                }
                
            } else if (currentSubPageName=="qc"){

                //we'll be using plugin name instead of just displaying "qc"
                var selectedTrackIndexStr=activeDevice.getState("selectedTrackIndex")
                
                if(selectedTrackIndexStr!=""){
                    
                    var selectedTrackIndex=parseInt(selectedTrackIndexStr)
                    var channelPluginNameToShow=cV.channelsProperties[selectedTrackIndex].pluginName
                
                    if(channelPluginNameToShow!=undefined){

                        row2OfMainDisplay=channelPluginNameToShow

                    }

                }
                
            }

            if(currentSubPageName=="fqc" || currentSubPageName=="fqc2"){

                dataText=sendOrAppendToSysEx(activeDevice,dataText,[8,cText,0].concat(getBytesFromText(row2OfMainDisplay),[8,cText,1],[32]))

            } else {

                var selectedTrackName=""
                var selectedTrackIndexStr=activeDevice.getState("selectedTrackIndex")
                if(selectedTrackIndexStr!=""){
               
                    selectedTrackName=activeDevice.getState("selectedTrackName"+selectedTrackIndexStr)
               
                    dataText=sendOrAppendToSysEx(activeDevice,dataText,[8,cText,0].concat(getBytesFromText(selectedTrackName),[8,cText,1],getBytesFromText(row2OfMainDisplay)))

                }

            }
                
            if(currentSubPageName in bindingsDisplayMap==true){
                
                var row=4
               
                var bindingsDisplayMapPerControlType=bindingsDisplayMap[currentSubPageName]
                var bindingsDisplayMapPerControlTypeKeys=Object.keys(bindingsDisplayMapPerControlType)
                
                bindingsDisplayMapPerControlTypeKeys.forEach(function(bindingsDisplayMapPerControlTypeKey){
                
                    if(bindingsDisplayMapPerControlTypeKey in bindingsDisplayRows){

                        row=bindingsDisplayRows[bindingsDisplayMapPerControlTypeKey]

                    } 
                   
                    var indexes=Object.keys(bindingsDisplayMapPerControlType[bindingsDisplayMapPerControlTypeKey])
                
                    indexes.forEach(function(controlIndex){
                    
                        var controlArr=bindingsDisplayMapPerControlType[bindingsDisplayMapPerControlTypeKey][controlIndex]
                
                        var commandShortName=controlArr[0]
                        var commandColor=controlArr[1]
                
                        var controlIndexInt=parseInt(controlIndex)
                        
                        if(controlIndexInt==-1 && bindingsDisplayMapPerControlTypeKey in bindingsDisplayColumns==true){

                            controlIndexInt=bindingsDisplayColumns[bindingsDisplayMapPerControlTypeKey]
                            
                        }

                        if (controlIndexInt>-1){
                            
                            var rowFinal=row
                            if(controlIndexInt>7){
                            
                                controlIndexInt=controlIndexInt-8
                                rowFinal=rowFinal+1
                            
                            }

                            dataText=sendOrAppendToSysEx(activeDevice,dataText,[controlIndexInt,cText,rowFinal].concat(getBytesFromText(commandShortName)))
                            
                        }
                        
                        if(bindingsDisplayMapPerControlTypeKey.indexOf("knob")==-1){

                            var ledObject
                            
                            if(controlIndex!="-1"){
                        
                                ledObject=cV.leds[bindingsDisplayColorMap[bindingsDisplayMapPerControlTypeKey]][controlIndex]
                        
                            } else {
                               
                                ledObject=cV.leds[bindingsDisplayMapPerControlTypeKey]
                            
                            }
                        
                            if(ledObject!=undefined){

                                if(["rewind","forward","stop","play","loop","record"].indexOf(bindingsDisplayMapPerControlTypeKey)==-1){

                                    dataColor=dataColor.concat([ledObject.ledID,1,commandColor[0],commandColor[1],commandColor[2]])
                                
                                }
                            
                            }
                            
                        }  
                     
                       
                        if(bindingsDisplayMapPerControlTypeKey.indexOf("button")==0 && controlIndexInt>-1 && cV.subPagesForDawInfoDisplay.indexOf(currentSubPageName)!=-1){
                            
                            updateDisplay(activeDevice,controlIndexInt,cColor,1,"",commandColor[0],commandColor[1],commandColor[2],0)
                            
                            if(controlIndexInt>1 && controlIndexInt<8 && currentSubPageName.indexOf("commands")==-1){
                                
                                //updating transport colors
                                var transportLedID=controlIndexInt==7 ? 32 : 31+controlIndexInt
                                sendSysex(activeDevice,0x03,transportLedID,[1].concat(commandColor))
                            
                            }
                            
                        }
                    
                    })
                
                })

                if(cV.subPagesForDawInfoDisplay.indexOf(currentSubPageName)!=-1){
                    
                    for(var displayIndex=0;displayIndex<8;displayIndex++){

                        updateDisplay(activeDevice,displayIndex,cColor,2,"",127,127,127,0)
                        updateDisplay(activeDevice,displayIndex,cValue,1,"",0,0,0,1)
               
                    }

                }
                 
            }

            if(currentSubPageName=="mixer" && generalSettings.display.pluginName==1){

                for(var chIndex=0;chIndex<8;chIndex++){

                    var channelPluginName=cV.channelsProperties[chIndex].pluginName

                    dataText=sendOrAppendToSysEx(activeDevice,dataText,[chIndex,cText,3].concat(getBytesFromText(channelPluginName)))
                    
                }
                
            }

            updateDisplay(activeDevice,8,cColor,0,"",this.color[0],this.color[1],this.color[2],0)
            
            if(this.buttonHeaders!=undefined){
            
                var buttonHeaderIndex=0
                this.buttonHeaders.forEach(function(buttonHeader){
                    
                    dataText=sendOrAppendToSysEx(activeDevice,dataText,[buttonHeaderIndex,cText,3].concat(getBytesFromText(buttonHeader)))
                    
                    buttonHeaderIndex++
                
                })

            }

            if (dataText.length>1){
            
               sendLongSysex(activeDevice,dataText)
            
            }
            

            if(currentSubPageName=="shift" && generalSettings.nightMode==1){
                
                //updating arrow colors
                dataColor.push(cV.leds.arrowUpPads.ledID,1,cV.leds.arrowUpPads.shiftColor[0],cV.leds.arrowUpPads.shiftColor[1],cV.leds.arrowUpPads.shiftColor[2])

                dataColor.push(cV.leds.arrowDnPads.ledID,1,cV.leds.arrowDnPads.shiftColor[0],cV.leds.arrowDnPads.shiftColor[1],cV.leds.arrowDnPads.shiftColor[2])

                dataColor.push(cV.leds.trackLeft.ledID,1,cV.leds.trackLeft.shiftColor[0],cV.leds.trackLeft.shiftColor[1],cV.leds.trackLeft.shiftColor[2])

                dataColor.push(cV.leds.trackRight.ledID,1,cV.leds.trackRight.shiftColor[0],cV.leds.trackRight.shiftColor[1],cV.leds.trackRight.shiftColor[2])
                
            } else if (currentSubPageName=="options" && generalSettings.nightMode==1){

                //updating right arrows (above faders)
                var subPageNameFaders=activeDevice.getState("buttonsAboveFaders")
                var colorUp=cV.colorsPerSubPageButton1Faders[subPageNameFaders][0]
                var colorDn=cV.colorsPerSubPageButton1Faders[subPageNameFaders][1]
                dataColor.push(cV.leds.arrowUpRight.ledID,1,colorUp[0],colorUp[1],colorUp[2])
                dataColor.push(cV.leds.arrowDnRight.ledID,1,colorDn[0],colorDn[1],colorDn[2])

                //setting for pad flashing
                dataColor.push(cV.leds.pads[7].ledID,3,127,0,0)
                //setting for pads synced
                dataColor.push(cV.leds.pads[15].ledID,3,127,0,127)
                //setting for night mode on/off
                dataColor.push(cV.leds.pads[8].ledID,3,127,127,0)
                //setting for metronome on off
                dataColor.push(cV.leds.record.ledID,3,0,127,0)
                
            }

            if (dataColor.length>1){
            
                sendLongSysex(activeDevice,dataColor)
            
            }
            
            
            if(cV.subPagesForDawInfoDisplay.indexOf(currentSubPageName)==-1 && currentSubPageName!="options"){

                if(generalSettings.pulsePad8==1){

                    var ledObject=cV.leds.pads[7]
                    ledObject.solidFlashPulse=2
                    ledObject.r=generalSettings.pulsePad8Color[0]
                    ledObject.g=generalSettings.pulsePad8Color[1]
                    ledObject.b=generalSettings.pulsePad8Color[2]
                    updateLed(activeDevice,ledObject)
                
                } else {

                    var ledObject=cV.leds.pads[7]
                    ledObject.solidFlashPulse=1
                    ledObject.r=generalSettings.pad8Color[0]*generalSettings.nightMode
                    ledObject.g=generalSettings.pad8Color[1]*generalSettings.nightMode
                    ledObject.b=generalSettings.pad8Color[2]*generalSettings.nightMode
                    updateLed(activeDevice,ledObject)
                
                }

                //updating mixer, channel settings, and instrument view pads
                if(generalSettings.nightMode==1){

                    sendLongSysex(activeDevice,[
                        0x03,
                        cV.leds.pads[13].ledID,1,generalSettings.pad14Color[0],generalSettings.pad14Color[1],generalSettings.pad14Color[2],
                        cV.leds.pads[14].ledID,1,generalSettings.pad15Color[0],generalSettings.pad15Color[1],generalSettings.pad15Color[2],
                        cV.leds.pads[15].ledID,1,generalSettings.pad16Color[0],generalSettings.pad16Color[1],generalSettings.pad16Color[2]
                    
                    ])

                } else {

                    sendLongSysex(activeDevice,[
                        0x03,
                        cV.leds.pads[13].ledID,1,0,0,0,
                        cV.leds.pads[14].ledID,1,0,0,0,
                        cV.leds.pads[15].ledID,1,0,0,0
                    
                    ])
                
                }
            
            }
            
            if(currentSubPageName=="mixer"){

                //we need to get the volume stored, because faders are not assigned to any of our subPageShift subPages 
            
                for(var faderIndex=0;faderIndex<8;faderIndex++){

                    var volume=cV.channelsProperties[faderIndex].volume 
                    if(volume==undefined){

                        volume=""
                    
                    }

                    var pan=cV.channelsProperties[faderIndex].pan 
                    if(pan==undefined){
                        
                        pan=""
                    
                    }

                    updateDisplay(activeDevice,faderIndex,cText,1,volume,0,0,0,0)

                    updateDisplay(activeDevice,faderIndex,cText,0,pan,0,0,0,0)

                    var trackName=activeDevice.getState("selectedTrackName"+faderIndex)
                    if(generalSettings.display.pluginName==1){

                        updateDisplay(activeDevice,faderIndex,cText,2,trackName,0,0,0,0)

                    } else {

                        sendTextTwoLines(activeDevice,faderIndex,2,trackName)
                    
                    }

                }
               
            }

        }.bind({subPageName,subPageIndex,subPagesAreaName,updateDisplayType,color,displayName,boundLed,buttonHeaders,section,subPageMappedIndex})

        subPages[subPageName].mOnDeactivate=function(activeDevice,activeMapping){
        
            activeDevice.setState("state"+this.subPageName,"0")

            if(this.boundLed!=undefined && typeof this.boundLed!="number"){
            
                var ledObject=this.boundLed
                ledObject.r=this.color[0]*generalSettings.nightMode*generalSettings.nightModePadsIntensity
                ledObject.g=this.color[1]*generalSettings.nightMode*generalSettings.nightModePadsIntensity
                ledObject.b=this.color[2]*generalSettings.nightMode*generalSettings.nightModePadsIntensity
            
                updateLed(activeDevice,ledObject)
                
            }

            if(this.subPageName=="options" && generalSettings.nightMode==1){

                //deactivating colors of arrow right and pad 9
                var nm2=generalSettings.nightModeOtherButtonsIntensity
                var optionsSysex=[
                    0x03,
                    cV.leds.arrowUpRight.ledID,1,cV.leds.arrowUpRight.night[0]*nm2,cV.leds.arrowUpRight.night[1]*nm2,cV.leds.arrowUpRight.night[1]*nm2,
                    cV.leds.arrowDnRight.ledID,1,cV.leds.arrowDnRight.night[0]*nm2,cV.leds.arrowDnRight.night[1]*nm2,cV.leds.arrowDnRight.night[1]*nm2,

                    cV.leds.pads[8].ledID,1,0,0,0

                ]

                sendLongSysex(activeDevice,optionsSysex)
            
            }

        }.bind({subPageName,boundLed,color})

        subPageIndex++

    })

    return [subPagesArea,subPages,subPagesSections,subPagesForNavigating]

}

function turnLeftRight(activeDevice,knobIndex,value,diff){
    
    var newStep=1
            
    if((value==0 && diff==0) || diff<0){
        
        newStep=-1
    
    }

    var start = new Date().getTime()
    
    var delay=generalSettings.delayMSForKnobsTurnInCommands
    
    if(activeDevice.getState("subPageShift")=="grid"){
    
        delay=generalSettings.delayMSForKnobsTurnInMCU
    
    } else if (knobIndex>5){

        delay=generalSettings.delayMSForKnobsTurnInOtherPages
    
    }

    if(cV.msFromLastKnobTurn==0 || start>cV.msFromLastKnobTurn+delay){
        
        if(newStep<0){

            ourSurface.knobsLeft[knobIndex].setProcessValue(activeDevice,1-ourSurface.knobsLeft[knobIndex].getProcessValue(activeDevice))
           
        } else if (newStep>0){
        
            ourSurface.knobsRight[knobIndex].setProcessValue(activeDevice,1-ourSurface.knobsRight[knobIndex].getProcessValue(activeDevice))
       
        }

        cV.msFromLastKnobTurn=start 
    
    }

}

function updateDawInfo(activeDevice,column,row,text){
    
    var selectedPage=activeDevice.getState("subPageShift")
 
    if(cV.subPagesForDawInfoDisplay.indexOf(selectedPage)>-1){
       
        

        updateDisplay(activeDevice,column,cText,row,text,0,0,0,0)
    
    }

}

function sendTextTwoLines(activeDevice,column,firstRow,text){

    var row1=""
    var row2=""
    
    if(text.length<cV.displayColumnLength){
        
        row1=text
    
    } else {

        row1=text.substring(0,cV.displayColumnLength)
        row2=text.substring(cV.displayColumnLength)
    
    }

    if(row1.length==0){

        row1=" "
    }

    if(row2.length==0){

        row2=" "
    
    }
    
    var row1Bytes=getBytesFromText(row1)
    var row2Bytes=getBytesFromText(row2)

    var finalSysex=cV.sysexHeader.concat([0x02,column,cText,firstRow],row1Bytes,[column,cText,firstRow+1],row2Bytes,[0xF7])

    midiOutput.sendMidi(activeDevice,finalSysex)

}

function Helper_updateBeats(activeDevice,beat){
   
    var prevBeatString=activeDevice.getState("beat")
    
    if(prevBeatString!=""){
        
        var prevBeat=parseInt(prevBeatString)
        var ledObject=cV.leds.pads[11+prevBeat]
        ledObject.r=0
        ledObject.g=0
        ledObject.b=0
        updateLed(activeDevice,ledObject)
        
    }
    
    activeDevice.setState("beat",""+beat)
    beat--
    var ledObject2=cV.leds.pads[12+beat]
    ledObject2.r=generalSettings.flashPadsColors[beat][0]
    ledObject2.g=generalSettings.flashPadsColors[beat][1]
    ledObject2.b=generalSettings.flashPadsColors[beat][2]
    updateLed(activeDevice,ledObject2)

}

function Helper_MCUChangeValue(activeDevice,knobIndex,incDec){
    
    var selectedSubPage=activeDevice.getState("subPageShiftprev")
  
    if(["mixer","qc","gate","comp","tools","sat","limit","inserts","sends"].indexOf(selectedSubPage)==-1){

        return 

    }
    
    var subPagesStrip=["gate","comp","tools","sat","limit"]

    var lastMCUPage=activeDevice.getState("lastMCUPage")

    var midiCCsArray=[]
    
    if(knobIndex<7 && selectedSubPage!="sends"){
        
        return 
    
    }
    
    if(selectedSubPage!=lastMCUPage){

        activeDevice.setState("lastMCUPage",selectedSubPage)

        //send initial ccs
        
        switch (true){
        
            case selectedSubPage=="mixer":
                
                midiCCsArray.push([0x90,cV.ccBrowseInstrument,127])
                midiCCsArray.push([0x80,cV.ccBrowseInstrument,127])
                
                break 

            case selectedSubPage=="qc":

                midiCCsArray.push([0x90,cV.ccBrowseInstrument,127])
                midiCCsArray.push([0x80,cV.ccBrowseInstrument,127])
            
                break 


            case selectedSubPage=="inserts":
                
                var insertIndex=activeDevice.getState("insertindex")
                var realIndex=parseInt(insertIndex)-1
                activeDevice.setState("insertindexprev",insertIndex)
                
                midiCCsArray.push([0x90,cV.ccBrowseInsert,127])
                midiCCsArray.push([0x80,cV.ccBrowseInsert,127])
                midiCCsArray.push([0xB0,cV.ccBrowseInsert2,realIndex])
                
                break 

            case subPagesStrip.indexOf(selectedSubPage)>-1:
                
                var subPageIndex=subPagesStrip.indexOf(selectedSubPage)
                subPageIndex=subPageIndex+2
                if(subPageIndex>1){
                
                    var otherSubPageIndex=subPageIndex-2
                    var indexInStrip=activeDevice.getState("stripeffect"+otherSubPageIndex+"index")
                    
                    var realIndex=parseInt(indexInStrip)-1
                    midiCCsArray.push([0x90,cV.ccBrowseStrip,127])
                    midiCCsArray.push([0x80,cV.ccBrowseStrip,127])
                    midiCCsArray.push([0xB0,cV.ccBrowseStrip2,realIndex])
                    
                }

                break 

            case selectedSubPage=="sends":
                
                midiCCsArray.push([0x90,cV.ccBrowseSend,127])
                midiCCsArray.push([0x80,cV.ccBrowseSend,127])
                
                midiCCsArray.push([0x90,cV.ccBrowseSend2,127])
                midiCCsArray.push([0x80,cV.ccBrowseSend2,127])

                midiCCsArray.push([0x90,cV.ccBrowseSend2,127])
                midiCCsArray.push([0x80,cV.ccBrowseSend2,127])

                midiCCsArray.push([0x90,cV.ccBrowseSend2,127])
                midiCCsArray.push([0x80,cV.ccBrowseSend2,127])

                break 
        
        }

    } else if (selectedSubPage=="inserts"){

        var insertIndex=activeDevice.getState("insertindex")
        var insertIndexPrev=activeDevice.getState("insertindexprev")
        
        if(insertIndex!=insertIndexPrev){

            activeDevice.setState("insertindexprev",insertIndex)
            var realIndex=parseInt(insertIndex)-1
            midiCCsArray.push([0x90,cV.ccBrowseInsert,127])
            midiCCsArray.push([0x80,cV.ccBrowseInsert,127])
            midiCCsArray.push([0xB0,cV.ccBrowseInsert2,realIndex])

        }
        
    }

    if(midiCCsArray.length>0){
                
        for(var midiMessageIndex=0;midiMessageIndex<midiCCsArray.length;midiMessageIndex++){

            var msg=midiCCsArray[midiMessageIndex]
            Helper_sendMIDIToLOOPMIDI(activeDevice,msg)

        }
        
    }

    var sendCC=0 

    if (selectedSubPage=="sends"){
        
        var sendSelected=knobIndex
        
        sendCC=cV.ccBrowseSendUpDown+sendSelected
    
    } else {

        sendCC=cV.ccBrowseUpDown 

    }

    var ccValue=cV.ccValueLeft
    
    if(incDec==1){

        ccValue=cV.ccValueRight
    
    }
    
    if(sendCC>0){

        Helper_sendMIDIToLOOPMIDI(activeDevice, [0xB0,sendCC,ccValue])
    
    }

}


/**
 * 
 * @param {MR_ActiveDevice} activeDevice 
 * @param {Array} midiMsg 
 */
function Helper_sendMIDIToLOOPMIDI(activeDevice,midiMsg){
    
    if(generalSettings.strippedDownVersion!=1){
        
        var newMCUCommandTimeStampToString=new Date().getTime().toString()
        activeDevice.setState("lastMCUCommandTimeStamp",newMCUCommandTimeStampToString)

        midiOutputMIDILOOP.sendMidi(activeDevice,midiMsg)
    
    }
    
}



function isSubPageSelected(activeDevice,subPageName){

    return activeDevice.getState("subPageShift")==subPageName
    
}

function updateNightModeButtons(activeDevice){


    var intenseB=generalSettings.nightModeOtherButtonsIntensity
    var nm2=intenseB*generalSettings.nightMode

    var duplicateR=cV.leds.duplicate.night[0]*nm2
    var duplicateB=cV.leds.duplicate.night[1]*nm2 
    var duplicateG=cV.leds.duplicate.night[2]*nm2 

    var clearR=cV.leds.clear.night[0]*nm2 
    var clearG=cV.leds.clear.night[1]*nm2 
    var clearB=cV.leds.clear.night[2]*nm2
    
    var trackLR=cV.leds.trackLeft.night[0]*nm2 
    var trackLG=cV.leds.trackLeft.night[1]*nm2 
    var trackLB=cV.leds.trackLeft.night[2]*nm2 


    var trackRR=cV.leds.trackRight.night[0]*nm2 
    var trackRG=cV.leds.trackRight.night[1]*nm2 
    var trackRB=cV.leds.trackRight.night[2]*nm2 

    var gridR=cV.leds.grid.night[0]*nm2
    var gridG=cV.leds.grid.night[1]*nm2
    var gridB=cV.leds.grid.night[2]*nm2

    var optionsR=cV.leds.options.night[0]*nm2
    var optionsG=cV.leds.options.night[1]*nm2
    var optionsB=cV.leds.options.night[2]*nm2

    var arrowUdR=cV.leds.arrowUpScreen.night[0]*nm2 
    var arrowUdG=cV.leds.arrowUpScreen.night[1]*nm2 
    var arrowUdB=cV.leds.arrowUpScreen.night[2]*nm2 

    var arrowDdR=cV.leds.arrowDnScreen.night[0]*nm2 
    var arrowDdG=cV.leds.arrowDnScreen.night[1]*nm2 
    var arrowDdB=cV.leds.arrowDnScreen.night[2]*nm2 
    
    var arrowDpR=cV.leds.arrowDnPads.night[0]*nm2 
    var arrowDpG=cV.leds.arrowDnPads.night[1]*nm2 
    var arrowDpB=cV.leds.arrowDnPads.night[2]*nm2 
    
    var arrowUpR=cV.leds.arrowUpPads.night[0]*nm2 
    var arrowUpG=cV.leds.arrowUpPads.night[1]*nm2 
    var arrowUpB=cV.leds.arrowUpPads.night[2]*nm2 

    var arrowR1R=cV.leds.arrowRightA.night[0]*nm2 
    var arrowR1G=cV.leds.arrowRightA.night[1]*nm2 
    var arrowR1B=cV.leds.arrowRightA.night[2]*nm2 
    
    var arrowR2R=cV.leds.arrowRightB.night[0]*nm2 
    var arrowR2G=cV.leds.arrowRightB.night[1]*nm2 
    var arrowR2B=cV.leds.arrowRightB.night[2]*nm2 

    var arrowUfR=cV.leds.arrowUpRight.night[0]*nm2 
    var arrowUfG=cV.leds.arrowUpRight.night[1]*nm2 
    var arrowUfB=cV.leds.arrowUpRight.night[2]*nm2 
    
    var arrowDfR=cV.leds.arrowDnRight.night[0]*nm2 
    var arrowDfG=cV.leds.arrowDnRight.night[1]*nm2 
    var arrowDfB=cV.leds.arrowDnRight.night[2]*nm2 
    
    
    var dataColor=[
    
        0x03,
        
        cV.leds.duplicate.ledID,1,duplicateR,duplicateG,duplicateB,
        cV.leds.clear.ledID,1,clearR,clearG,clearB,

        cV.leds.trackLeft.ledID,1,trackLR,trackLG,trackLB,
        cV.leds.trackRight.ledID,1,trackRR,trackRG,trackRB,
    
        cV.leds.arrowRightA.ledID,1,arrowR1R,arrowR1G,arrowR1B,
        cV.leds.arrowRightB.ledID,1,arrowR2R,arrowR2G,arrowR2B,
        
        cV.leds.grid.ledID,1,gridR,gridG,gridB,
        cV.leds.options.ledID,1,optionsR,optionsG,optionsB,

        cV.leds.arrowUpScreen.ledID,1,arrowUdR,arrowUdG,arrowUdB,
        cV.leds.arrowDnScreen.ledID,1,arrowDdR,arrowDdG,arrowDdB,

        cV.leds.arrowUpPads.ledID,1,arrowUpR,arrowUpG,arrowUpB,
        cV.leds.arrowDnPads.ledID,1,arrowDpR,arrowDpG,arrowDpB,

        cV.leds.arrowUpRight.ledID,1,arrowUfR,arrowUfG,arrowUfB,
        cV.leds.arrowDnRight.ledID,1,arrowDfR,arrowDfG,arrowDfB
    
    ]

    sendLongSysex(activeDevice,dataColor)

}

function makeCustomPage(pageName){

    var page=makePageWithDefaults(pageName)

    var subPagesShiftArea=page.makeSubPageArea("subPageShift")
    var subPageDefault=subPagesShiftArea.makeSubPage("default")
    var subPageShift=subPagesShiftArea.makeSubPage("shift")

    var dummyVarForArrows=page.mCustom.makeHostValueVariable("dummyVarForArrows")

    page.makeActionBinding(ourSurface.buttons.shift.mSurfaceValue,subPageShift.mAction.mActivate).setSubPage(subPageDefault)
    page.makeActionBinding(ourSurface.buttons.shift.mSurfaceValue,subPageDefault.mAction.mActivate).setSubPage(subPageShift)
    
    page.makeActionBinding(ourSurface.buttons.arrowUpPads.mSurfaceValue,deviceDriver.mAction.mNextPage).setSubPage(subPageShift)

    page.makeActionBinding(ourSurface.buttons.arrowDnPads.mSurfaceValue,deviceDriver.mAction.mPrevPage).setSubPage(subPageShift)

    page.makeValueBinding(ourSurface.buttons.arrowUpPads.mSurfaceValue,dummyVarForArrows).setSubPage(subPageDefault)

    page.makeValueBinding(ourSurface.buttons.arrowDnPads.mSurfaceValue,dummyVarForArrows).setSubPage(subPageDefault)


    var onActivate = function (activeDevice) {
      
        activeDevice.setState("selectedPage",pageName)

        sendSysex(activeDevice,1,1,[])
      
    }
    
    return {page,onActivate} 

}


function updateKnobsWhenInChangePluginIdentity(activeDevice,updateFadersToo,updateKnobs){

    //this function is used because when we have a changePlugInIdentity the knobs are not getting updated, while buttons are. I consider this to be a bug
    
    for(var knobIndex=0;knobIndex<8;knobIndex++){

        if(updateKnobs==true){

            ourSurface.knobs[knobIndex].mSurfaceValue.setProcessValue(activeDevice,ourSurface.knobs[knobIndex].mSurfaceValue.getProcessValue(activeDevice))

        }
        
        if(updateFadersToo==true){

            ourSurface.faders[knobIndex].mSurfaceValue.setProcessValue(activeDevice,ourSurface.faders[knobIndex].mSurfaceValue.getProcessValue(activeDevice))
            
        }

    }
    
}


function updateSelectedTrack(activeDevice,controlIndex,value){

    var r=cV.channelsProperties[controlIndex].colorR
    var g=cV.channelsProperties[controlIndex].colorG
    var b=cV.channelsProperties[controlIndex].colorB
            
    var ledObject2=cV.leds.faders[controlIndex]

    if(value==0){
    
        ledObject2.solidFlashPulse=0x01
        ledObject2.intensity=generalSettings.display.nonSelectedTracksColorIntensityButtonsFaders
    
    } else {
        
        activeDevice.setState("selectedTrackIndex",controlIndex.toString())
        
        if(activeDevice.getState("selectedPage")==cV.constPageNameMixer && ["fqc","fqc2","inserts"].indexOf(activeDevice.getState("subPageShift"))==-1){
        
            var trackName=activeDevice.getState("selectedTrackName"+controlIndex)
        
            updateDisplay(activeDevice,8,cText,0,trackName,0,0,0,0)
        
        }

        if(generalSettings.display.selectedTracksAppearanceOptionFaders==1){
    
            ledObject2.solidFlashPulse=0x03
    
        } else {

            ledObject2.solidFlashPulse=0x01

        }
    
        ledObject2.intensity=1
    
    }
    
   
    var selectedPage=activeDevice.getState("selectedPage")
    var isMixerSelected=selectedPage=="mixer"
    
    if(isMixerSelected==true){

        updateLed(activeDevice,ledObject2)

        if(activeDevice.getState("subPageShift")=="mixer"){

            var ledObject=cV.leds.underDisplay[controlIndex]

            if(value==0){

                ledObject.solidFlashPulse=0x01
                ledObject.intensity=generalSettings.display.nonSelectedTracksColorIntensityButtonsScreens
            } else {

                if(generalSettings.display.selectedTracksAppearanceOptionScreens==1){
            
                    ledObject.solidFlashPulse=0x03 
        
                } else {

                    ledObject.solidFlashPulse=0x01 
        
                }
        
                ledObject.intensity=1
            }

            updateDisplay(activeDevice,controlIndex,cColor,2,"",r,g,b,0)
            updateDisplay(activeDevice,controlIndex,cValue,1,"",0,0,0,value)

            updateLed(activeDevice,ledObject)

        }
    
    }
    
}

function updateSelectedTrackColor(activeDevice,controlIndex,r,g,b,a,isActive,isMixerOn){

    cV.channelsProperties[controlIndex].colorR=Math.round(r*127)
    cV.channelsProperties[controlIndex].colorG=Math.round(g*127)
    cV.channelsProperties[controlIndex].colorB=Math.round(b*127)
    
    var show=1
    
    if(isActive==false){
        
        show=0
    
    }

    cV.channelsProperties[controlIndex].active=show 

    if(show==0){

        cV.channelsProperties[controlIndex].pluginName=""
        cV.channelsProperties[controlIndex].volume=""
        cV.channelsProperties[controlIndex].volume127=0

    }

    var ledObject=cV.leds.underDisplay[controlIndex]
    ledObject.r=Math.round(127*r*show)
    ledObject.g=Math.round(127*g*show)
    ledObject.b=Math.round(127*b*show)
    
    var r127=ledObject.r
    var g127=ledObject.g
    var b127=ledObject.b 

    if(isMixerOn==true){
        
        updateDisplay(activeDevice,controlIndex,cColor,1,"",r127,g127,b127,0)  

    }
    
    if(activeDevice.getState("selectedPage")=="mixer"){

        var ledObjectFaders=cV.leds.faders[controlIndex]
        ledObjectFaders.r=r127 
        ledObjectFaders.g=g127 
        ledObjectFaders.b=b127 
        updateLed(activeDevice,ledObjectFaders)

        if(show==0){

            var ledObjectFaders1=cV.leds.aboveFaders1[controlIndex]
            ledObjectFaders1.r=0
            ledObjectFaders1.g=0
            ledObjectFaders1.b=0
            updateLed(activeDevice,ledObjectFaders1)

            var ledObjectFaders2=cV.leds.aboveFaders2[controlIndex]
            ledObjectFaders2.r=0
            ledObjectFaders2.g=0
            ledObjectFaders2.b=0
            updateLed(activeDevice,ledObjectFaders2)
        
        }

    }    

}


function updateMetronomeState(activeDevice){
   
    if(activeDevice.getState("recording")=="1" || generalSettings.transport.showMetronomeStateAtRecordButton!=1){

        return 

    }
    
    var currentSubPageName=activeDevice.getState("subPageShift")

    if(["shift","shift2","ctrl","alt","fn"].indexOf(currentSubPageName)!=-1){

        return 

    }

    var rgb=cV.metroActive==0 ? [0,0,0] : generalSettings.transport.showMetronomeStateAtRecordButtonColor
    
    var ledObject=cV.leds.record  
    ledObject.r=rgb[0]
    ledObject.g=rgb[1]
    ledObject.b=rgb[2]

    if(generalSettings.transport.showMetronomeStateAtRecordButtonLevelAdjusted==1){

    
        ledObject.r=Math.round(ledObject.r*cV.clickLevel/127)
        ledObject.g=Math.round(ledObject.g*cV.clickLevel/127)
        ledObject.b=Math.round(ledObject.b*cV.clickLevel/127)

    }
    
    updateLed(activeDevice,ledObject)

}

function updatePunchInState(activeDevice){
    
    if(generalSettings.transport.showPunchInAtRewindButton!=1){

        return 

    }
    
    var punchIn=activeDevice.getState("punchIn")

    if(punchIn==""){punchIn="0"}

    var rgb=punchIn=="0" ? [0,0,0] : generalSettings.transport.showPunchInAtRewindButtonColor
    
    var ledObject=cV.leds.rewind
    ledObject.r=rgb[0]
    ledObject.g=rgb[1]
    ledObject.b=rgb[2]

    updateLed(activeDevice,ledObject)
    
}

function updatePunchOutState(activeDevice){
    
    if(generalSettings.transport.showPunchOutAtForwardButton!=1){

        return 

    }
    
    var punchOut=activeDevice.getState("punchOut")

    if(punchOut==""){punchOut="0"}

    var rgb=punchOut=="0" ? [0,0,0] : generalSettings.transport.showPunchOutAtForwardButtonColor
    
    var ledObject=cV.leds.forward 
    ledObject.r=rgb[0]
    ledObject.g=rgb[1]
    ledObject.b=rgb[2]

    updateLed(activeDevice,ledObject)
    
}

function makePageWithDefaults(pageName){

    var page=deviceDriver.mMapping.makePage(pageName)

    page.makeValueBinding(ourSurface.dummy.metronomeActive.mSurfaceValue,page.mHostAccess.mTransport.mValue.mMetronomeActive).mOnValueChange=function(activeDevice,activeMapping,value,diff){
        
        var metroActive= value==0 ? "Metro OFF" : "Metro ON"
        cV.metroActive=value 
        updateDawInfo(activeDevice,5,1,metroActive)

        updateMetronomeState(activeDevice)
    
    }

    page.makeValueBinding(ourSurface.dummy.clickLevel.mSurfaceValue,page.mHostAccess.mTransport.mValue.mMetronomeClickLevel).mOnValueChange=function(activeDevice,activeMapping,value,diff){

        var clickLevel=Math.round(127*value)

        cV.clickLevel=clickLevel    
        updateDawInfo(activeDevice,6,1,""+clickLevel)

        if(generalSettings.transport.showMetronomeStateAtRecordButtonLevelAdjusted==1){

            updateMetronomeState(activeDevice)

        }
        
    }

    page.makeValueBinding(ourSurface.buttons.play.mSurfaceValue,page.mHostAccess.mTransport.mValue.mStart)
    .mOnValueChange=function(activeDevice,activeMapping,value,diff){
       
        var ledObject=cV.leds.play
        ledObject.g=127*value 
        updateLed(activeDevice,ledObject)

        activeDevice.setState("isPlaying",""+value)
    
    }

    page.makeValueBinding(ourSurface.buttons.loop.mSurfaceValue,page.mHostAccess.mTransport.mValue.mCycleActive).setTypeToggle()
    .mOnValueChange=function(activeDevice,activeMapping,value,diff){
    
        var ledObject=cV.leds.loop 
        ledObject.b=127*value 
        updateLed(activeDevice,ledObject)
    
    }
	
	page.makeValueBinding(ourSurface.buttons.record.mSurfaceValue,page.mHostAccess.mTransport.mValue.mRecord).setTypeToggle()
    .mOnValueChange=function(activeDevice,activeMapping,value,arg3){
    
        var ledObject=cV.leds.record
        ledObject.r=127*value 
        ledObject.g=0
        ledObject.b=0
        
        updateLed(activeDevice,ledObject)

        activeDevice.setState("recording",""+value)

        if(value==0){

            updateMetronomeState(activeDevice)

        }
    
    }

   
    page.makeValueBinding(ourSurface.buttons.stop.mSurfaceValue,page.mHostAccess.mTransport.mValue.mStop).setTypeToggle()
    .mOnValueChange=function(activeDevice,activeMapping,value,arg3){

        var ledObject=cV.leds.stop 
        ledObject.r=127*value 
        ledObject.g=127*value 
        ledObject.b=127*value 
        
        updateLed(activeDevice,ledObject)

        if(generalSettings.flashPadsInSync==1){

            var prevBeatString=activeDevice.getState("beat")
    
            if(prevBeatString!=""){
        
                var prevBeat=parseInt(prevBeatString)
                var ledObject=cV.leds.pads[11+prevBeat]
                ledObject.r=0
                ledObject.g=0
                ledObject.b=0
                updateLed(activeDevice,ledObject)
        
            }
    
        }
    
    }

    page.makeActionBinding(ourSurface.buttons.trackLeft.mSurfaceValue,page.mHostAccess.mTrackSelection.mAction.mPrevTrack)
    page.makeActionBinding(ourSurface.buttons.trackRight.mSurfaceValue,page.mHostAccess.mTrackSelection.mAction.mNextTrack)

    page.makeValueBinding(ourSurface.buttons.rewind.mSurfaceValue,page.mHostAccess.mTransport.mValue.mRewind)

    page.makeValueBinding(ourSurface.buttons.forward.mSurfaceValue,page.mHostAccess.mTransport.mValue.mForward)

    return page 

}

function updateAllSectionsPads(activeDevice){
    
    var msg=[0x03]
    
    for(var i=0;i<cV.colorsPerMainSection.length;i++){
    
        var padIndex=i==7 ? 12 : i
        var color=cV.colorsPerMainSection[i]
        var r=color[0]*generalSettings.nightModePadsIntensity*generalSettings.nightMode
        var g=color[1]*generalSettings.nightModePadsIntensity*generalSettings.nightMode
        var b=color[2]*generalSettings.nightModePadsIntensity*generalSettings.nightMode
        msg.push(0x26+padIndex,1,r,g,b)
    
    }
    
    sendLongSysex(activeDevice,msg)

}